\name{fExtremesBUILTIN}

\alias{decluster} 
\alias{emplot}
\alias{exindex}
\alias{findthresh} 
\alias{gev} 
\alias{gev.dens} 
\alias{gev.diag} 
\alias{gev.fit}
\alias{gev.his}
\alias{gev.pp} 
\alias{gev.prof} 
\alias{gev.profxi} 
\alias{gev.qq} 
\alias{gev.rl} 
\alias{gevf} 
\alias{gevq} 
\alias{gpd} 
\alias{gpd.dens} 
\alias{gpd.diag} 
\alias{gpd.fit} 
\alias{gpd.fitrange} 
\alias{gpd.his} 
\alias{pot}
\alias{gpd.pp} 
\alias{gpd.prof} 
\alias{gpd.profxi}
\alias{gpd.q} 
\alias{gpd.qq} 
\alias{gpd.rl} 
\alias{gpd.sfall} 
\alias{gpdbiv} 
\alias{gpdf} 
\alias{gpdq} 
\alias{gpdq2} 
\alias{gum.dens} 
\alias{gum.df}
\alias{gum.diag} 
\alias{gum.fit} 
\alias{gum.q} 
\alias{gum.rl} 
\alias{gumbel} 
\alias{hill} 
\alias{identity} 
\alias{interpret.gpdbiv}
\alias{meplot} 
\alias{mrl.plot} 
\alias{plot.gev} 
\alias{plot.gpd} 
\alias{plot.gpdbiv} 
\alias{plot.pot} 
\alias{pp.diag}
\alias{pp.fit} 
\alias{pp.fitrange} 
\alias{pp.pp} 
\alias{pp.qq} 
\alias{ppf}
\alias{ppp} 
\alias{ppq} 
\alias{q.form} 
\alias{qplot} 
\alias{quant}
\alias{records} 
\alias{riskmeasures} 
\alias{rlarg.diag} 
\alias{rlarg.fit} 
\alias{rlarg.pp} 
\alias{rlarg.qq} 
\alias{rlargf}
\alias{rlargq} 
\alias{rlargq2} 
\alias{rlevel.gev} 
\alias{shape} 
\alias{tailplot}


\alias{bmw}
\alias{danish} 
\alias{dowjones} 
\alias{engine} 
\alias{euroex} 
\alias{exchange} 
\alias{fremantle} 
\alias{glass}
\alias{nidd.annual} 
\alias{nidd.thresh} 
\alias{portpirie}
\alias{rain} 
\alias{siemens} 
\alias{sp.raw} 
\alias{spto87} 
\alias{venice}
\alias{wavesurge} 
\alias{wind} 
\alias{wooster}


\title{fExtremes Builtin Functions}


\description{

	fExtremes Builtin Functions from EVIR and ISMEV Packages
	
}

\keyword{data}

\eof
\name{evPlots}

\alias{evPlots}

\alias{emdPlot}
\alias{qqPlot}
\alias{qqbayesPlot}
\alias{qPlot}
\alias{mePlot}
\alias{mrlPlot}
\alias{mxfPlot}
\alias{msratioPlot}
\alias{recordsPlot}
\alias{ssrecordsPlot}
\alias{xacfPlot}

\alias{interactivePlot}

\alias{gridVector}

\title{Explorative Data Analysis}


\description{

	This is a collection of functions for explorative data analysis of
	extreme values. The tools include plot functions for emprical 
	distributions, quantile plots, graphs exploring the properties of 
	exceedences over a threshold, plots for mean/sum ratio and for the 
	development of records.
	\cr
	
	The functions are:
	
	\tabular{rll}{
	 1 	\tab 	\code{emdPlot}			
	 	\tab	Plot of empirical distribution function, \cr
	 2 	\tab	\code{qqPlot}			
	 	\tab	Normal quantile-quantile plot, \cr
	 3 	\tab 	\code{qqbayesPlot}		
	 	\tab	Normal QQ-Plot with 95 percent intervals, \cr
	 4 	\tab	\code{qPlot}			
	 	\tab	Exponential/Pareto quantile plot, \cr
	 5 	\tab	\code{mePlot}			
	 	\tab	Plot of mean excesses over a threshold, \cr
	 6 	\tab	\code{mrlPlot}			
	 	\tab	another variant, mean residual life plot, \cr
	 7 	\tab	\code{mxfPlot}			
	 	\tab	another variant, with confidence intervals, \cr
     8 	\tab	\code{msratioPlot}		
     	\tab	Plot of the ratio of maximum and sum, \cr	
	 9	\tab	\code{recordsPlot}		
	 	\tab	Record development compared with iid data, \cr
	10 	\tab	\code{ssrecordsPlot}	
		\tab	another variant, investigates subsamples, \cr
	11 	\tab	\code{xacfPlot}	 	
		\tab	ACF of exceedences over a threshold, \cr
	12	\tab	\code{interactivePlot}
		\tab 	a framework for interactive plot displays, \cr
	13	\tab	\code{gridVector}
		\tab 	creates from two vectors x and y all grid points. }
	
}


\usage{
emdPlot(x, doplot = TRUE, plottype = <<see below>>, labels = TRUE, \dots)

qqPlot(x, doplot = TRUE, labels = TRUE, \dots) 
qqbayesPlot(x, doplot = TRUE, labels = TRUE, \dots)
qPlot(x, xi = 0, trim = NA, threshold = NA, doplot = TRUE, labels = TRUE, \dots)

mePlot(x, doplot = TRUE, labels = TRUE, \dots)
mrlPlot(x, conf = 0.95, umin = NA, umax = NA, nint = 100, doplot = TRUE, 
	plottype = <<see below>>, labels = TRUE, \dots)  
mxfPlot(x, tail = 0.05, doplot = TRUE, labels = TRUE, \dots)  
   
msratioPlot(x, p = 1:4, doplot = TRUE, plottype = <<see below>>, 
	labels = TRUE, \dots) 
   
recordsPlot(x, conf = 0.95, doplot = TRUE, labels = TRUE, \dots)
ssrecordsPlot(x, subsamples = 10, doplot = TRUE, plottype = <<see below>>,
	labels = TRUE, \dots)

xacfPlot(x, threshold = 0.95, lag.max = 15, doplot = TRUE, \dots)

interactivePlot(x, choices = paste("Plot", 1:9), 
	plotFUN = paste("plot.", 1:9, sep = ""), which = "all", \dots)
	
gridVector(x, y)
}


\arguments{

  	\item{choices}{
  		[interactivePlot] - \cr
  		a vector of character strings for the
  		choice menu. By Default \code{"Plot 1"} ... \code{"Plot 9"}
  		allowing for 9 plots at maximum.
  		}
  	\item{conf}{
  		[recordsPlot] - \cr
		a confidence level. By default 0.95, i.e. 95\%.
		}
  	\item{doplot}{
		a logical. Should the results be plotted? By default \code{TRUE}.
		}
  	\item{labels}{
		a logical. Whether or not x- and y-axes should be automatically 
		labelled and a default main title should be added to the plot.
		By default \code{TRUE}.
		}
    \item{lag.max}{
    	[xacfPlot] - \cr
		maximum number of lags at which to calculate the autocorrelation 
		functions. The default value is 15.
		}
  	\item{nint}{
  		[mrlPlot] - \cr
    	the number of intervals, see \code{umin} and \code{umax}. The 
    	default value is 100.
    	}
  	\item{p}{
  		[msratioPlot] - \cr
		the power exponents, a numeric vector. By default a sequence from  
		1 to 4 in unit integer steps.
		}
  	\item{plotFUN}{
  		[interactivePlot] - \cr
  		a vector of character strings naming the
  		plot functions. By Default \code{"plot.1"} ... \code{"plot.9"}
  		allowing for 9 plots at maximum.
  		}
  	\item{plottype}{
  		[emdPlot] - \cr
		which axes should be on a log scale: \code{"x"} x-axis only; 
		\code{"y"} y-axis only; \code{"xy"} both axes; \code{""} 
		neither axis.
		\cr
		[msratioPlot] - \cr
  		a logical, if set to \code{"autoscale"}, then the scale of the 
  		plots are automatically determined, any other string allows user
  		specified scale information through the \code{\dots} argument.
  		\cr
  		[ssrecordsPlot] - \cr
    	one from two options can be select either \code{"lin"}
    	or \code{"log"}. The default creates a linear plot.
    	}
  	\item{subsamples}{
  		[ssrecordsPlot] - \cr
		the number of subsamples, by default 10, an integer value.
		}
  	\item{tail}{
  		[mxfPlot] - \cr
		the threshold determined from the relative number of data points 
		defining the tail, a numeric value; by default 0.05 which says 
		that 5\% of the data make the tail.
		}
  	\item{threshold, trim}{
  		[qPlot][xacfPlot] - \cr
		a numeric value at which data are to be left-truncated, value 
		at which data are to be right-truncated or the thresold value, 
		by default 95\%.
		}
  	\item{umin, umax}{
  		[mrlPlot] - \cr
    	range of threshold values. If \code{umin} and/or \code{umax} are 
    	not available, then by default they are set to the following 
    	values: \code{umin=mean(x)} and \code{umax=max(x)}.
    	}
    \item{which}{
   		plot selection, which graph should be displayed? If \code{"which"}
   		is a character string named "ask" the user is interactively asked 
   		which to plot, if a logical vector of length \code{N}, those plots 
   		which are set \code{TRUE} are displayed, if a character string
		named \code{"all"} all plots are displayed.
		}
  	\item{x, y}{
		a numeric data vector or an object to be plotted. 
		\cr
		[gridVector] - \cr
		two numeric vector which span the two dimensional grid.	
		}
	\item{xi}{
		the shape parameter of the generalized Pareto distribution.
		}
	\item{\dots}{
    	additional arguments passed to the plot function.
    	}
		
}


\details{
  
	\bold{Empirical Distribution Function:}
	\cr\cr
	The function \code{emdPlot} is a simple explanatory function. A 
	straight line on the double log scale indicates Pareto tail behaviour.
  	\cr
  	
  	
  	\bold{Quantile--Quantile Plot:}
  	\cr\cr		
  	The function \code{qqPlot} produces a normal QQ-plot. Note, that 
  	\code{qqPlot} is not a synonym function call to the \R-base function 
  	\code{qqplot} which produces a quantile-quantile plot of two datasets.  	
  	To help with assessing the relevance of sampling variability on just
	"how close" to the normal the data appears, \code{qqbayesPlot} adds 
	approximate posterior 95% intervals for the uncertain quantile 
	function at each point.
  	\code{qPlot} creates a QQ-plot for threshold data. If \code{xi} is 
  	zero the reference distribution is the exponential; if \code{xi} is 
  	non-zero the reference distribution is the generalized Pareto with 
  	that value of \code{xi}. In the case of the exponential, the plot is 
  	interpreted as follows: Concave departures from a straight line are a 
  	sign of heavy-tailed behaviour, convex departures show thin-tailed 
  	behaviour. 
  	\cr
  	
  		
  	\bold{Mean Excess Function Plot:}
	\cr\cr
	Three variants to plot the mean excess function are available: 
	A sample mean excess plot over increasing thresholds, and two mean 
	excess function plots with confidence intervals for discrimination 
	in the tails of a distribution.
	In general, an upward trend in a mean excess function plot shows 
	heavy-tailed behaviour. In particular, a straight line with positive 
	gradient above some threshold is a sign of Pareto behaviour in tail. 
	A downward trend shows thin-tailed behaviour whereas a line with 
	zero gradient shows an exponential tail. Here are some hints:
	Because upper plotting points are the average of a handful of extreme 
	excesses, these may be omitted for a prettier plot. 
	For \code{mrlPlot} and \code{mxfPlot} the upper tail is investigated; 
	for the lower tail reverse the sign of the \code{data} vector.
	\cr
	
	
	\bold{Plot of the Maximum/Sum Ratio:}
	\cr\cr
	The ratio of maximum and sum is a simple tool for detecting heavy 
	tails of a distribution and for giving a rough estimate of
	the order of its finite moments. Sharp increases in the curves
	of a \code{msratioPlot} are a sign for heavy tail behaviour.
	\cr
	
	
	\bold{Plot of the Development of Records:}
	\cr\cr
	These are functions that investigate the development of records in 
	a dataset and calculate the expected behaviour for iid data.
	\code{recordPlot} counts records and reports the observations 
	at which they occur. In addition subsamples can be investigated
	with the help of the function \code{ssrecords}.
	\cr
	
  	
  	\bold{ACF Plot of Exceedences over a Thresold:}
  	\cr\cr
  	This function plots the autocorrelation functions of heights and 
  	distances of exceedences over a threshold.

}


\note
{

	The plots are labeled by default with a x-label, a y-label and
	a main title. If the argument \code{label} is set to \code{FALSE}
	neither a x-label, a y-label nor a main title will be added to 
	graph. To add user defined label strings "\dots" just use the 
	function \code{title(xlab="\dots", ylab="\dots", main="\dots")}.
	
}


\author{

 	Some of the functions were implemented from Alec Stephenson's 
 	R-package \code{evir} ported from Alexander McNeil's S library 
 	\code{EVIS}, \emph{Extreme Values in S}, some from Alec Stephenson's 
 	R-package \code{ismev} based on Stuart Coles code from his book, 
 	\emph{Introduction to Statistical Modeling of Extreme Values} and 
 	some were written by Diethelm Wuertz.
  	
}


\references{

Coles S. (2001);
	\emph{Introduction to Statistical Modelling of Extreme Values},
	Springer.
	
Embrechts, P., Klueppelberg, C., Mikosch, T. (1997);
	\emph{Modelling Extremal Events}, Springer.  
	
}


\examples{ 
## emdPlot -
   xmpExtremes("\nStart: Empirical Distribution Function >")
   # Danish fire insurance data show Pareto tail behaviour:
   par(mfrow = c(2, 2))
   data(danish)
   emdPlot(danish, plottype = "xy", labels = FALSE)
   title(xlab = "x", ylab = "1-F(x)", main = "Danish Fire")   
   # BMW Stocks:
   data(bmw)
   emdPlot(bmw, plottype = "xy", labels = FALSE)
   title(xlab = "x", ylab = "1-F(x)", main = "BMW Stocks")  
   # Simulated Student-t:
   emdPlot(rt(5000, 4), plottype = "xy") 
 
## qqPlot -
   xmpExtremes("\nNext: Quantile-Quantile Plot >")
   # QQ-Plot of Simulated Normal rvs:
   par(mfrow = c(2, 2))
   set.seed(4711)
   qqPlot(rnorm(5000))
   text(-3.5, 3, pos = 4, "Simulated Normal rvs")
   # QQ-Plot of simulated Student-t rvs:
   qqPlot(rt(5000, 4))
   text(-3.5, 11.0, pos = 4, "Simulated Student-t rvs")
   # QQ-Plot of BMW share residuals:
   data(bmw)
   qqPlot(bmw)
   text(-3.5, 0.09, pos = 4, "BMW log returns")     
   
## qPlot -
   xmpExtremes("\nNext: QQ-Plot of Heavy Tails >")
   # QQ-Plot of heavy-tailed Danish fire insurance data:
   data(danish)
   qPlot(danish) 
 
## mePlot -
   xmpExtremes("\nNext: Mean Excess Plot >")
   # Sample mean excess plot of heavy-tailed Danish fire 
   # insurance data 
   par(mfrow = c(3, 2))
   data(danish)
   mePlot(danish, labels = FALSE)
   title(xlab = "u", ylab = "e", main = "mePlot - Danish Fire Data")
   
## mrlPlot -
   xmpExtremes("\nNext: mean Residual Live Plot >")
   # Sample mean residual live plot of heavy-tailed Danish Fire 
   # insurance data 
   mrlPlot(danish, labels = FALSE)
   title(xlab = "u", ylab = "e", main = "mrlPlot - Danish Fire Data")
 
## mxfPlot -
   xmpExtremes("\nNext: Mean Excess Function Plot >")
   # Plot the mean excess functions for randomly distributed 
   # residuals 	
   par(mfrow = c(2, 2))
   n = 10000	
   set.seed(4711)
   xlab = "Threshold: u"; ylab = "Mean Excess: e"
   mxfPlot(rnorm(n), tail = 0.5, labels = FALSE)
   title(xlab = xlab, ylab = ylab, main = "mxf Plot - Normal DF")
   set.seed(7138)
   mxfPlot(rexp(n, 2), tail = 0.5, labels = FALSE)
   title(xlab = xlab, ylab = ylab, main = "mxfPlot - Exponential DF")
   abline(1/2, 0)
   set.seed(6952)
   mxfPlot(rlnorm(n, 0, 2), tail = 0.5, xlim = c(0,90), 
     ylim = c(0, 120), labels = FALSE)
   title(xlab = xlab, ylab = ylab, main = "mxfPlot - Lognormal DF")
   set.seed(8835)
   mxfPlot(rgpd(n, 1/2), tail = 0.10, xlim = c(0,200), 
   	 ylim=c(0,200), labels = FALSE)
   title(xlab = xlab, ylab = ylab, main = "mxfPlot - Pareto")
   abline(0, 1)  
 
## msratioPlot -
   xmpExtremes("\nNext: Maximum/Sum Ratio Plot >")
   # Examples for Ratio of Maximum and Sum Plots:
   par(mfrow = c(3, 2))
   data(bmw)
   xlab = "n"; ylab = "R(n)"
   msratioPlot (rnorm(8000), labels = FALSE)
   title(xlab = xlab, ylab = ylab, main = "Standard Normal")
   msratioPlot (rexp(8000), labels = FALSE)
   title(xlab = xlab, ylab = ylab, main = "Exponential")
   msratioPlot (rt(8000, 4), labels = FALSE)
   title(xlab = xlab, ylab = ylab, main = "Student-t")
   msratioPlot (rcauchy(8000), labels = FALSE)
   title(xlab = xlab, ylab = ylab, main = "Cauchy")
   msratioPlot (bmw, labels = FALSE)
   title(xlab = xlab, ylab = ylab, main = "BMW Returns")
  
## recordsPlot -
   xmpExtremes("\nNext: Records Plot >")
   # Record fire insurance losses in Denmark
   par(mfrow = c(2, 2))
   data(danish)
   recordsPlot(danish)
   text(1, 7.9, pos = 4, "Danish Fire")
   # BMW Stocks
   data(bmw)
   recordsPlot(bmw)
   text(1, 12.8, pos = 4, "BMW Shares")
      
## ssrecordsPlot -
   xmpExtremes("\nNext: Subsample Record Plot >")
   # Record fire insurance losses in Denmark
   ssrecordsPlot(danish)
   text(1, 9.2, pos = 4, "Danish Fire")
   # BMW Stocks
   ssrecordsPlot(bmw)
   text(1, 10.5, pos = 4, "BMW Shares")  
 
## xacfPlot -
   xmpExtremes("\nNext: ACF Plot of Exceedences >")
   # Plot ACF of Heights/Distances of Eceedences over threshold:
   par(mfrow = c(2, 2))
   data(bmw)
   xacfPlot(bmw)
}


\keyword{hplot}


\eof
\name{getExtremes}

\alias{getExtremes}

\alias{findThreshold}
\alias{blocks}
\alias{blockMaxima}
\alias{deCluster}

\title{Get and Preprocess Extreme Value Data}

\description{

	This is a collection of functions for preprocessing data for extreme 
	value analysis. Included are tools to separate data beyond a threshold
	value, to compute blockwise data like block maxima, and to decluster
	point process data.
	\cr
	
	The functions are:
	
	\tabular{rll}{
	1	\tab 	\code{findThreshold}
		\tab 	Upper threshold for a given number of extremes, \cr  
	2	\tab 	\code{blocks}         
		\tab	Create data blocks on vectors and time series, \cr
	3	\tab 	\code{blockMaxima}	
		\tab	Block Maxima from a vector or a time series, \cr 
	4	\tab 	\code{deCluster} 		
		\tab	Declusters clustered point process data. }
	
}


\usage{
findThreshold(x, n = NA)
blocks(x, block = "month", FUN = max)
blockMaxima(x, block = "month", details = FALSE, doplot = TRUE, \dots)
deCluster(x, run = NA, doplot = TRUE)
}


\arguments{
  
  	\item{block}{
    	the block size. A numeric value is interpreted as the number  
    	of data values in each successive block. All the data is used,
    	so the last block may not contain \code{block} observations. 
    	If the \code{data} has a  \code{times} attribute containing (in
    	an object of class \code{"POSIXct"}, or an object that can be
    	converted to that class, see \code{\link{as.POSIXct}}) the
    	times/dates of each observation, then \code{block} may instead
    	take the character values \code{"month"}, \code{"quarter"},
    	\code{"semester"} or \code{"year"}. By default monthly blocks
    	from daily data are assumed.
    	}
  	\item{details}{[blockMaxima] -
  		a logical. Should details be printed?
  		}
  	\item{doplot}{
  		a logical. Should the results be plotted?
  		}
  	\item{FUN}{the function to be applied. Additional arguments are
  		passed by the \code{\dots} argument.
  		}
  	\item{n}{[findThreshold] -
		a numeric value or vector giving number of extremes above 
		the threshold. If \code{n} is not specified, \code{n} is 
		set to an integer representing 5\% of the data from the 
		whole data set \code{x}.
		}
	\item{run}{[deCluster] - 
		parameter to be used in the runs method; any two consecutive 
		threshold exceedances separated by more than this number of 
		observations/days are considered to belong to different clusters.
		}    
	\item{x}{
		a numeric data vector from which \code{findThreshold} and 
		\code{blockMaxima} determine the threshold values and block 
		maxima values. 
		For the function \code{deCluster} the argument
		\code{x} represents a numeric vector of threshold exceedances
		with a \code{times} attribute which should be a numeric
		vector containing either the indices or the times/dates
		of each exceedance (if times/dates, the attribute should
		be an object of class \code{"POSIXct"} or an object that
		can be converted to that class; see \code{\link{as.POSIXct}}).
		}
	\item{\dots}{
    	additional arguments passed to the FUN or plot function.
		}
		
}


\details{
  
	\bold{Finding Thresholds:} 
	\cr\cr
	The function \code{findThreshold} finds a threshold so that a given 
	number of extremes lie above. When the data are tied a threshold is 
	found so that at least the specified number of extremes lie above.
	\cr
	
  
	\bold{Computing Block Maxima:} 
	\cr\cr	
	The function \code{blockMaxima} calculates block maxima from a vector 
	or a time series, whereas the function
	\code{blocks} is more general and allows for the calculation of
	an arbitrary function \code{FUN} on blocks.
	\cr
	
		
	\bold{De-Clustering Point Processes:} 
	\cr\cr
	The function \code{deCluster} declusters clustered point process 
	data so that Poisson assumption is more tenable over a high threshold.
  	 	
}


\value{
  
	\code{findThreshold} 
	\cr
	returns a numeric vector of suitable thresholds. 
	
	\code{blockMaxima} 
	\cr
	returns a numeric vector of block maxima data.
	
	\code{deCluster} 
	\cr
	returns an object for the declustered point process. 

}


\references{

Embrechts, P., Klueppelberg, C., Mikosch, T. (1997);
  	\emph{Modelling Extremal Events},
  	Springer Verlag. 
  	 
}



\seealso{
  
 	\code{\link{mdaPlots}}, 
  	\code{\link{exindexPlots}}, 
  	\code{\link{gpdFit}},
  	\code{\link{potFit}}.
  	
}


\examples{  
## findThreshold -
   xmpExtremes("\nStart: Find Thresold >")
   # Find threshold giving (at least) fifty exceedances 
   # for Danish Fire data
   data(danish)
   findThreshold(danish, n = c(10, 50, 100))    
   
## blockMaxima -
   xmpExtremes("\nNext: Compute Block Maxima >")
   # Block Maxima (Minima) for the right and left tails 
   # of the BMW log returns:
   data(bmw)
   par(mfrow = c(2, 1))
   blockMaxima( bmw, block = 100)
   blockMaxima(-bmw, block = 100)     
 
## deCluster -
   xmpExtremes("\nNext: De-Cluster Exceedences >")
   # Decluster the 200 exceedances of a particular  
   # threshold in the negative BMW log-return data
   par(mfrow = c(2, 2))
   fit = potFit(-bmw, nextremes = 200) 
   deCluster(fit$fit$data, 30)   
}


\keyword{data}


\eof
\name{gevFamily}

\alias{gevFamily}

\alias{dgev}
\alias{pgev}
\alias{qgev}
\alias{rgev}

\alias{devd}
\alias{pevd}
\alias{qevd}
\alias{revd}


\title{GEV Distributions for Extreme Value Theory}


\description{

	This is a collection of distribution functions used in extreme 
	value theory. The functions compute density, distribution function, 
	quantile function and generate random deviates for the Generalized 
	Extreme Value Distribution, GEV, for the Frechet, Gumbel, and Weibull 
	distributions.
	\cr
	
	The functions are:
	
	\tabular{rll}{
	1	  \tab	\code{dgev}		
		  \tab	Density of the GEV Distribution, \cr
	2 	  \tab	\code{pgev}			
		  \tab	Probability function of the GEV Distribution, \cr
	3 	  \tab	\code{qgev}			
		  \tab	Quantile function of the GEV Distribution, \cr
	4 	  \tab	\code{rgev}		
		  \tab	Random variates from the GEV Distribution. \cr
	5-8	  \tab	\code{[dpqr]frechet}	
		  \tab	Frechet Distribution, \cr
	9-12  \tab	\code{[dpqr]gumbel}	
		  \tab	Gumbel Distribution, \cr
	13-16 \tab	\code{[dpqr]weibull}	
		  \tab	Weibull Distribution, \cr
	17-20 \tab	\code{[dpqr]evd}		
		  \tab	An alternative call for the GEV Distribution. }
	
}


\usage{
dgev(x, xi = 1, mu = 0, sigma = 1, log = FALSE)
pgev(q, xi = 1, mu = 0, sigma = 1, lower.tail = TRUE)
qgev(p, xi = 1, mu = 0, sigma = 1, lower.tail = TRUE)
rgev(n, xi = 1, mu = 0, sigma = 1)

devd(x, loc = 0, scale = 1, shape = 0, log = FALSE)
pevd(q, loc = 0, scale = 1, shape = 0, lower.tail = TRUE)
qevd(p, loc = 0, scale = 1, shape = 0, lower.tail = TRUE)
revd(n, loc = 0, scale = 1, shape = 0)
}


\arguments{

	\item{loc, scale, shape}{
		\code{loc} is the location parameter, 
		\code{scale} the scale parameter,
		and \code{shape} is the shape parameter.
		The default values are \code{loc=0}, \code{scale=1}, and 
		\code{shape=0}.
		}
	\item{log}{
	    a logical, if \code{TRUE}, the log density is returned.
	    }
  	\item{lower.tail}{
	    a logical, if \code{TRUE}, the default, then
	    probabilities are \code{P[X <= x]}, otherwise, \code{P[X > x]}.
	    }
	\item{n}{
		the number of observations.
		} 
	\item{p}{
		a numeric vector of probabilities.
		}
	\item{q}{
		a numeric vector of quantiles.
		}
	\item{x}{
		a numeric vector of quantiles.
		}
	\item{xi, mu, sigma}{
		\code{xi} is the shape parameter, 
		\code{mu} the location parameter,
		and \code{sigma} is the scale parameter.
		The default values are \code{xi=1}, \code{mu=0}, and 
		\code{sigma=1}.
		}
		
}


\value{
	
	All values are numeric vectors: \cr
	\code{d*} returns the density, \cr
	\code{p*} returns the probability, \cr
	\code{q*} returns the quantiles, and \cr
	\code{r*} generates random variates. \cr
}


\details{

	\bold{Generalized Extreme Value Distribution:}
	\cr\cr
	Computes density, distribution function, quantile function and 
	generates random variates for the Generalized Extreme Value 
	Distribution, GEV, for the Frechet, Gumbel, and Weibull 
	distributions.
		
}

\note{

	Here we implemented the notation for the arguments as used
	by the GEV functions in the EVIS package or SPlus/FinMetrics 
	module. Additional arguments to these packages are the \code{log} 
	and the \code{lower.tail} arguments, underlying the code
	from R's \code{evd} package.
	
	An alternative usage is proposed by the \code{evd} package.
	There the following arguments are used:\cr
	
	\code{*gev(x, loc = 0, scale = 1, shape = 0, ...)}\cr
	
	What you prefer is a matter of taste. The GEV functions from
	the \code{evd} package are renamed from \code{*gev} to \code{*evd}
	so that both versions are available. 
	 
	In addition functions for the density, probability, quantiles, 
	and the generation of random variates for the 
	Frechet \code{[dpqr]frechet},
	Gumbel \code{[dpqr]gumbel}, and
	Weibull \code{[dpqr]weibull} are also available.
    \cr
	
	If you stay with both versions you can access the help page for 
	\code{evds}'s function \code{dgev} by \code{help(dgev, package="evd")}.
	
}


\author{

	Alec Stephenson for the functions from R's \code{evd} package, and \cr
	Diethelm Wuertz for this \R-port.
	
}


\references{
Embrechts, P., Klueppelberg, C., Mikosch, T. (1997);
	\emph{Modelling Extremal Events}, Springer.  
}


\seealso{
  
	\code{\link{gevFit}},
  	\code{\link{gpdFit}}.
  	
}


\examples{
## *gev  -
   xmpExtremes("\nStart: GEV Frechet >")
   # Create and plot 1000 GEV/Frechet distributed rdv:
   par(mfrow = c(3, 3))
   r = rgev(n = 1000, xi = 1)
   plot(r, type = "l", main = "GEV/Frechet Series")
   ## Plot empirical density and compare with true density:
   ## Omit values greater than 500 from plot
   hist(r[r<10], n = 25, probability = TRUE, xlab = "r", 
     xlim = c(-5, 5), ylim = c(0, 1.1), main = "Density")
   x = seq(-5, 5, by=0.01)
   lines(x, dgev(x, xi = 1), col = 2)
   ## Plot df and compare with true df:
   plot(sort(r), (1:length(r)/length(r)), 
     xlim = c(-3, 6), ylim = c(0, 1.1),
   	 cex = 0.5, ylab = "p", xlab = "q", main = "Probability")
   q = seq(-5,5, by=0.1)
   lines(q, pgev(q, xi=1), col=2)
## Compute quantiles, a test:
   qgev(pgev(seq(-5, 5, 0.25), xi = 1), xi = 1) 
   
## *gev -
   xmpExtremes("\nNext: GEV Gumbel >")
   # Create and plot 1000 Gumbel distributed rdv:
   ##> r = rgev(n = 1000, xi = 0)
   ##> plot(r, type = "l", main = "Gumbel Series")
   ## Plot empirical density and compare with true density:
   ##>hist(r[abs(r)<10], nclass = 25, freq = FALSE, xlab = "r", 
   ##>	 xlim = c(-5,5), ylim = c(0,1.1), main = "Density")
   ##>x = seq(-5, 5, by = 0.01)
   ##>lines(x, dgev(x, xi = 0), col=2)
   ## Plot df and compare with true df:
   ##>plot(sort(r), (1:length(r)/length(r)), 
   ##>  xlim = c(-3, 6), ylim = c(0, 1.1),
   ##>	 cex=0.5, ylab = "p", xlab="q", main="Probability")
   ##>q = seq(-5, 5, by = 0.1)
   ##>lines(q, pgev(q, xi = 0), col = 2)
   ## Compute quantiles, a test:
   ##>qgev(pgev(seq(-5, 5, 0.25), xi = 0), xi = 0)   

## *gev -
   xmpExtremes("\nNext: GEV Weibull >")
   # Create and plot 1000 Weibull distributed rdv:
   r = rgev(n = 1000, xi = -1)
   plot(r, type = "l", main = "Weibull Series")
   ## Plot empirical density and compare with true density:
   hist(r[abs(r)<10], nclass = 25, freq = FALSE, xlab = "r", 
   	 xlim=c(-5,5), ylim=c(0,1.1), main="Density")
   x = seq(-5, 5, by=0.01)
   lines(x, dgev(x, xi = -1), col = 2)
   ## Plot df and compare with true df:
   plot(sort(r), (1:length(r)/length(r)), 
     xlim = c(-3, 6), ylim = c(0, 1.1),
   	 cex = 0.5, ylab = "p", xlab = "q", main = "Probability")
   q=seq(-5, 5, by = 0.1)
   lines(q, pgev(q, xi = -1), col = 2)
   ## Compute quantiles, a test:
   qgev(pgev(seq(-5, 5, 0.25), xi = -1), xi = -1)   
}


\keyword{distribution}


\eof
\name{gevFit}

\alias{gevSim}
\alias{gevFit}

\alias{print.gevFit}
\alias{plot.gevFit}
\alias{summary.gevFit}

\alias{gevrlevelPlot}


\title{Modelling GEV Distribution}


\description{
  
	This is a collection of functions to model the Generalized Extreme 
	Value, GEV, distribution based on \R's \code{evir} package. Two 
	types of approaches for parameter estimation are provided: Maximum 
	likelihood estimation and  probability weighted moment method.
	\cr
	
	The functions are:
	
	\tabular{rll}{
	1 	\tab	\code{gevSim}			
		\tab	generates data from the GEV, \cr
	2 	\tab	\code{gevFit}			
		\tab 	fits empirical or simulated data to the distribution, \cr 
	3 	\tab	\code{print} 			
		\tab	print method for a fitted GEV object, \cr
  	4 	\tab	\code{plot} 			
  		\tab	plot method for a fitted GEV object, \cr 
  	5 	\tab 	\code{summary}			
  		\tab	summary method for a fitted GEV object, \cr
  	6 	\tab	\code{gevrlevelPlot}	
  		\tab 	k-block return level with confidence intervals. }
  	 
}


\usage{
gevSim(model = list(shape = 0.25, location = 0, scale = 1), n = 1000)
gevFit(x, block = NA, type = c("mle", "pwm"), gumbel = FALSE, \dots)

\method{print}{gevFit}(x, \dots)
\method{plot}{gevFit}(x, which = "all", \dots)
\method{summary}{gevFit}(object, doplot = TRUE, which = "all", \dots)

gevrlevelPlot(object, k.blocks = 20, add = FALSE, \dots)
}


\arguments{

  	\item{add}{
  		[gevrlevelPlot] -
	    whether the return level should be added graphically to a
	    time series plot; if \code{FALSE} a graph of the profile
	    likelihood curve showing the return level and its confidence
	    interval is produced.
	    }
    \item{block}{
    	[gevFit] -
	    the block size. Only used if \code{method="mle"} is selected.
	    A numeric value is interpreted as the
	    number of data values in each successive block. All the data is
	    used, so the last block may not contain \code{block} observations.
	    If the \code{data} has a \code{times} attribute containing (in
	    an object of class \code{"POSIXct"}, or an object that can be
	    converted to that class; see \code{\link{as.POSIXct}}) the
	    times/dates of each observation, then \code{block} may instead
	    take the character values \code{"month"}, \code{"quarter"},
	    \code{"semester"} or \code{"year"}.
	    }
  	\item{doplot}{
		a logical. Should the results be plotted?
		}
    \item{gumbel}{
    	[gevFit] -
	    a logical, by default FALSE. To fit a Gumbel model with fixed
	    \code{shape=0} set \code{gumbel=TRUE}.
	    }
	\item{k.blocks}{
		[gevrlevelPlot] -
	    specifies the particular return level to be estimated; default 
	    set arbitrarily to 20.
	    }
   	\item{model}{
   		[gevSim] - 
		a list with components \code{shape}, \code{location} and 
		\code{scale} giving the parameters of the GEV distribution.
		By default the shape parameter has the value 0.25, the
		location is zero and the scale is one.
		To fit random deviates from a Gumbel distribution set 
		\code{shape=0}.
		}
   	\item{n}{
   		[gevSim] -
		number of generated data points, an integer value.
		}
	\item{object}{
  		[summary][grlevelPlot] -
    	a fitted object of class \code{"gevFit"}.
    	}
    \item{type}{
    	a character string denoting the type of parameter estimation,
    	either by maximum likelihood estimation \code{"mle"}, the
    	default value, or by the probability weighted moment menthod
    	\code{"pwm"}.
    	}
   	\item{which}{
   		[plot][summary] -
	    a vector of logicals, one for each plot, denoting which plot 
	    should be displayed. Alkternatively if \code{which="ask"} the
	    user will be interactively asked which of the plots should be
	    desplayed. By default \code{which="all"}.
	    }
   	\item{x}{
   		[gevFit] -
    	data vector. In the case of \code{method="mle"} the interpretation 
    	depends on the value of block: if no block size is specified then 
    	data are interpreted as block maxima; if block size is set, then data
    	are interpreted as raw data and block maxima are calculated. 
    	[print][plot] -
    	a fitted object of class \code{"gevFit"}.
    	}
    \item{\dots}{
    	[gevFit] -
    	control parameters optionally passed to the 
    	optimization function. Parameters for the optimization
    	function are passed to components of the \code{control} argument of
    	\code{optim}. 
    	[plot][summary] -
    	arguments passed to the plot function.
    	}    

}


\value{
  
	\code{gevSim}
	\cr
	returns a vector of datapoints from the simulated series.
	\cr

  	\code{gevFit}
  	\cr
  	returns an object of class \code{gev} describing the fit.
  	\cr
  
  	\code{print.summary}
  	\cr
  	prints a report of the parameter fit.
  	\cr
  	
  	\code{summary}
  	\cr
  	performs diagnostic analysis. The method provides two different 
  	residual plots for assessing the fitted GEV model.  
  	\cr
  
  	\code{gevrlevelPlot}
  	\cr
  	returns a vector containing the lower 95\% bound of the confidence 
  	interval, the estimated return level and the upper 95\% bound. 
  	
}


\details{

	\bold{Parameter Estimation:}
	\cr\cr
	\code{gevFit} estimates the parameters either by the probability 
	weighted moment method, \code{method="pwm"} or by maximum log 
	likelihood estimation \code{method="mle"}. 
  	As a limiting case the Gumbel distribution can be selected. The 
  	summary method produces diagnostic plots for fitted GEV or Gumbel 
  	models.
  	\cr
  
  	\bold{Methods:}
  	\cr\cr
  	\code{print.gev}, \code{plot.gev} and \code{summary.gev} are
  	print, plot, and summary methods for a fitted object of class 
  	\code{gev}. Concerning the summary method, the data are 
  	converted to unit exponentially distributed residuals under null 
  	hypothesis that GEV fits. Two diagnostics for iid exponential data 
  	are offered. The plot method provides two different residual plots 
  	for assessing the fitted GEV model. Two diagnostics for 
  	iid exponential data are offered. 
  	\cr
  
  	\bold{Return Level Plot:}
  	\cr\cr
  	\code{gevrlevelPlot} calculates and plots the k-block return level 
  	and 95\% confidence interval based on a GEV model for block maxima, 
  	where \code{k} is specified by the user. The k-block return level 
  	is that level exceeded once every \code{k} blocks, on average. The 
  	GEV likelihood is reparameterized in terms of the unknown return 
  	level and profile likelihood arguments are used to construct a 
  	confidence interval. 
  	
}


\note{	
  
	If method \code{"mle"} is selected the parameter fitting in \code{gevFit} 
  	is passed to the internal function \code{gev.mle} or \code{gumbel.mle}
  	depending on the value of \code{gumbel}, \code{FALSE} or \code{TRUE}.
  	On the other hand, if method \code{"pwm"} is selected the parameter 
  	fitting in \code{gevFit} is passed to the internal function 
  	\code{gev.pwm} or \code{gumbel.pwm} again depending on the value of 
  	\code{gumbel}, \code{FALSE} or \code{TRUE}.
  		
}


\references{

Embrechts, P., Klueppelberg, C., Mikosch, T. (1997);
  	\emph{Modelling Extremal Events}, 
  	Springer.
  	
}


\author{
  
	This function is based on Alec Stephenson's R-package \code{evir} 
  	ported from the \code{EVIS} library, \emph{Extreme Values in S},
  	written by Alexander McNeil. The \code{fExtremes} port and the 
  	change and addition of some functions were done by Diethelm Wuertz.
  	
}


\seealso{
  
	\code{\link{gevglmFit}},
  	\code{\link{gevFamily}}.
  	
}

  
\examples{
## Simulate GEV Data:
   xmpExtremes("\nStart: Simulte GEV Sample >")
   # Use default length n=1000
   x = gevSim(model = list(shape = 0.25, location =0 , scale = 1))
   # Fit GEV Data by Probability Weighted Moments:
   fit = gevFit(x, type = "pwm") 
   print(fit)
   # Summarize Results:
   par(mfcol = c(3, 2))
   summary(fit)
   
## Fit GEV Data by Max Log Likelihood Method:
   xmpExtremes("\nNext: Estimate Parameters >")
   fit = gevFit(x, type = "mle") 
   print(fit)
   # Summarize Results:
   summary(fit) 
    
## Simulate Gumbel Data:
   xmpExtremes("\nNext: Simulte Gumbel Sample >")
   # Use default length n=1000
   ##> x = gevSim(model = list(shape = 0, location = 0, scale = 1))
   # Fit Gumbel Data by Probability Weighted Moments:
   ##> fit = gevFit(x, type = "pwm", gumbel = TRUE) 
   ##> print(fit)
   # Summarize Results:
   ##> par(mfcol = c(3, 2))
   ##> summary(fit)  
   
## Fit Gumbel Data by Max Log Likelihood Method:
   xmpExtremes("\nNext: Estimate Parameters >")
   ##> fit = gevFit(x, type = "mle", gumbel = TRUE) 
   ##> print(fit)
   # Summarize Results:
   ##> summary(fit)     
   ##> xmpExtremes("Press any key to continue >") 
   
## Return levels based on GEV Fit:
   # BMW Stock Data:
   xmpExtremes("\nNext: Compute BMW Return Levels >")
   par(mfrow = c(2, 1))
   data(bmw)
   # Fit GEV to monthly Block Maxima:
   fit = gevFit(-bmw, block = "month") 
   # Calculate the 40 month return level
   gevrlevelPlot(fit, k.block = 40, main = "BMW: Return Levels")   
   
## Return levels based on GEV Fit:
   xmpExtremes("\nNext: Compute SIEMENS Return Levels >")
   # Siemens Stock Data:
   data(siemens)
   # Fit GEV to monthly Block Maxima:
   fit = gevFit(-siemens, block = "month") 
   # Calculate the 40 month return level
   gevrlevelPlot(fit, k.block = 40, main = "SIEMENS: Return Levels")
   
## Interactive Plot:
   ##> par(mfrow = c(1, 1), ask = TRUE)
   ##> plot(fit)
}


\keyword{models}


\eof
\name{gevglmFit}

\alias{gevglmFit}

\alias{print.gevglmFit}
\alias{plot.gevglmFit}
\alias{summary.gevglmFit}

\alias{gevglmprofPlot}
\alias{gevglmprofxiPlot}


\title{Maximum-likelihood Fitting of the GEV Distribution}


\description{
  
	This is a collection of functions to model the Generalized Extreme 
	Value, GEV, distribution by maximum likelihood approximation based 
	on \R's \code{ismev} package. In addition to \code{gevFit} the parameter 
	estimation allows to include generalized linear modelling of each 
	parameter, therefore the name \code{gevglmFit}.
	\cr
	
	The functions are:
	
	\tabular{rll}{
	1 	\tab	\code{gevglmFit} 			
		\tab	fits empirical or simulated data to the distribution, \cr 
  	2 	\tab	\code{print}  				
  		\tab	print method for a fitted GEV object of class ..., \cr
  	3 	\tab	\code{plot}  				
  		\tab	plot method for a fitted GEV object, \cr 
  	4 	\tab	\code{summary}  			
  		\tab	summary method for a fitted GEV object, \cr
  	5 	\tab	\code{gevglmprofPlot}		
  		\tab	profile log-likelihoods for return levels, \cr 
  	6 	\tab	\code{gevglmprofxiPlot}	
  		\tab	profile log-likelihoods for shape parameters. }
  	
}


\usage{
gevglmFit(x, y = NULL, gumbel = FALSE, mul = NULL, sigl = NULL, shl = NULL, 
    mulink = identity, siglink = identity, shlink = identity, show = FALSE, 
    method = "Nelder-Mead", maxit = 10000, \dots)

\method{print}{gevglmFit}(x, \dots)
\method{plot}{gevglmFit}(x, which = "ask", \dots)
\method{summary}{gevglmFit}(object, doplot = TRUE, which = "all", \dots)

gevglmprofPlot(object, m, xlow, xup, conf = 0.95, nint = 100)
gevglmprofxiPlot(object, xlow, xup, conf = 0.95, nint = 100)
}


\arguments{
  
  	\item{conf}{
  		[gevglmprof*Plot] -
	    the confidence coefficient of the plotted profile confidence 
	    interval.
	    }
	\item{doplot}{
		a logical. Should the results be plotted?
		} 
    \item{gumbel}{
    	[gevglmFit] - 
	    a logical, should a Gumbel fit be created? In this case the shape
	    parameter equals zero, and the arguments \code{shl} and and 
	    \code{shlink} are omitted.
	    }
  	\item{m}{
  		[gevglmprofPlot] -
	    the return level; i.e. the profile likelihood is for the value 
	    that is exceeded with probability 1/\code{m}.
	    }
  	\item{maxit}{
  		[gevglmFit] -
	    the maximum number of iterations.
	    }
  	\item{method}{
  		[gevglmFit] - 
	    the optimization method (see \code{\link{optim}} for details).
	    }
  	\item{mul, sigl, shl}{
  		[gevglmFit] - 
	    numeric vectors of integers, giving the columns
	    of \code{ydat} that contain covariates for generalized linear
	    modelling of the location, scale and shape parameters repectively
	    (or \code{NULL} (the default) if the corresponding parameter is
	    stationary).
	    }
 	\item{mulink, siglink, shlink}{
 		[gevglmFit] - 
	    inverse link functions for generalized linear modelling of the 
	    location, scale and shape parameters repectively.
	    }
  	\item{nint}{
  		[gevglmprof*Plot] -
	    the number of points at which the profile likelihood is evaluated.
	    } 
	\item{object}{
  		[summary][grlevelPlot] -
    	a fitted object of class \code{"gevglmFit"}.
    	}
    \item{show}{
		[gevglmFit] -
	    a logical; if \code{TRUE} (the default), print details of
	    the fit.
	    }
  	\item{x}{
  		[gevglmFit] -
	   	a numeric vector of data to be fitted.
	   	\cr
    	[print][plot] -
    	a fitted object of class \code{"gevglmFit"}.
	    }
	\item{xlow, xup}{
		[gevglmprof*Plot] -
	    the least and greatest value at which to evaluate the profile 
	    likelihood.
	    }
  	\item{y}{
  		[gevglmFit] -
	    a matrix of covariates for generalized linear modelling
	    of the parameters (or \code{NULL} (the default) for stationary
	    fitting). The number of rows should be the same as the length
	    of \code{xdat}.
	    }
  	\item{which}{
  		[plot][summary] -
	    a vector of logicals, one for each plot, denoting which plot 
	    should be displayed.
	    }
	\item{\dots}{
		[gevglmFit] -
    	control parameters optionally passed to the 
    	optimization function. Parameters for the optimization
    	function are passed to components of the \code{control} argument of
    	\code{optim}. 
    	\cr
    	[plot][summary] -
    	arguments passed to the plot function.
    	}     
	    
}


\value{
  
  	\code{gevglmFit}
  	\cr
  	returns a list containing the following components.
  	A subset of these components are printed after the fit. If \code{show} 
  	is \code{TRUE}, then assuming that successful convergence is
  	indicated, the components \code{nllh}, \code{mle} and \code{se}
  	are always printed.
  
  	\item{trans}{
    	an logical indicator for a non-stationary fit.
    	}
  	\item{model}{
    	a list with components \code{mul}, \code{sigl}
    	and \code{shl}.
    	}
  	\item{link}{
    	a character vector giving inverse link functions.
    	}
  	\item{conv}{
    	the convergence code, taken from the list returned by
    	\code{\link{optim}}. A zero indicates successful convergence.
    	}
  	\item{nllh}{
    	the negative logarithm of the likelihood evaluated at
    	the maximum likelihood estimates.
    	}
  	\item{data}{
    	the data that has been fitted. For non-stationary
    	models, the data is standardized.
    	}
  	\item{mle}{
    	a vector containing the maximum likelihood estimates.
    	}
  	\item{cov}{
    	the covariance matrix.
    	}
  	\item{se}{
    	a vector containing the standard errors.
    	}
  	\item{vals}{
    	a matrix with three columns containing the maximum
    	likelihood estimates of the location, scale and shape parameters
    	at each data point.
    	}  
    
  	For stationary models four plots are produced; a probability
  	plot, a quantile plot, a return level plot and a histogram
  	of data with fitted density. For non-stationary models two plots 
  	are produced; a residual probability plot and a residual quantile 
  	plot.
  	\cr
  
  	\code{gevglmprofPlot}\cr
  	\code{gevglmprofxiPlot}\cr
  	a plot of the profile likelihood is produced, with a horizontal line 
  	representing a profile confidence interval with confidence coefficient 
  	\code{conf}.
  
}


\details{

	\bold{Simulation:}
	\cr\cr
	To simulate a GEV series use the function \code{gevSim}. 
	\cr
	
	\bold{Parameter Estimation:}
	\cr\cr
	\code{gevglmFit} fits by the Maximum-likelihood approach the generalized 
  	extreme value distribution, including generalized linear modelling 
  	of each parameter. 
  	\cr
  
  	\bold{Methods:}
  	\cr\cr
  	\code{print.gevglm}, \code{plot.gevglm} and \code{summary.gevglm} 
  	are print, plot, and summary methods for a fitted object of class 
  	\code{gevglmFit}.
  	\cr
  
  	\bold{Profile Likelihood:}
  	\cr\cr
  	\code{gevglmprofPlot} and \code{gevglmprofxiPlot} produce profile 
  	log-likelihoods for shape parameters and \code{m} year/block return 
  	levels for stationary GEV models using the output of the function 
  	\code{gevFit}.
  	\cr

  	\bold{Nonstationary Models:}
  	\cr\cr
  	For non-stationary fitting it is recommended that the covariates
  	within the generalized linear models are (at least approximately)
  	centered and scaled (i.e.\ the columns of \code{ydat} should be
  	approximately centered and scaled).
  	
}


\author{
  
	Alec Stephenson for the code implemented from \R's ismev package, \cr
	Stuart Scott for the original code, and
	Diethelm Wuertz for this \R-port.
  	
}


\references{

Coles S. (2001);
	\emph{Introduction to Statistical Modelling of Extreme Values},
	Springer.  
	
}


\seealso{
  
  	\code{\link{gevFit}},
  	\code{\link{gevFamily}}.
  	
}

  
\examples{
## Simulated GEV Data:
   xmpExtremes("\nStart: Simulte GEV Sample >")
   x = gevSim(model = list(shape = 0.25, location = 0, scale = 1), n = 1000)
   par(mfrow = c(2, 2))
   plot(x, main = "Simulated GEV Data")
   # Fit GEV Data:
   fit = gevglmFit(x) 
   print(fit)
   # Summarize Results:
   summary(fit, which = c(TRUE, TRUE, TRUE, FALSE))
   
## Simulated GEV Data:
   xmpExtremes("\nNext: Estimate Parameters >")
   ##> x = gevSim(model = list(shape = 0, location = 0, scale = 1), n = 1000)
   ##> par(mfrow = c(2, 2))
   ##> plot(x, main = "Simulated Gumbel Data")
   # Fit GEV Data:
   ##> fit = gevglmFit(x, gumbel = TRUE) 
   ##> print(fit)
   # Summarize Results:
   ##> summary(fit, which = c(TRUE, TRUE, TRUE, FALSE))
   
## Portpirie Data:
   xmpExtremes("\nNext: Fit Portpirie Data >")
   par(mfrow = c(2, 1))
   data(portpirie)
   fit = gevglmFit(portpirie[, 2])
   gevglmprofPlot(fit, m = 10, 4.1, 5)
   title(main = "Portpirie")
   gevglmprofxiPlot(fit, -0.3, 0.3)
   title(main = "Portpirie")
   
## Interactive Plot:
   ##> par(mfrow = c(2, 2))
   ##> plot(fit)
}


\keyword{models}


\eof
\name{mdaPlots}

\alias{mdaPlots}

\alias{hillPlot}
\alias{shaparmPlot}
\alias{shaparmPickands}
\alias{shaparmHill}
\alias{shaparmDEHaan}

\title{Hill and Shape Parameter Plots}


\description{
  
    This is a collection of functions for the estimation of the tail
    index of extreme data using the maximum domain of attraction, MDA,
    method. Included are the Pickands, Einmal-Decker-deHaan, and Hill
    estimators together with several plot variants.
    \cr
	
    The functions are:
    
    \tabular{rll}{
    1	\tab	\code{hillPlot}
    	\tab	shape parameter and Hill estimate of the tail index, \cr
	2 	\tab	\code{shaparmPlot}	
		\tab 	variation of shape parameter with tail depth. }
  	
}


\usage{
hillPlot(x, option = c("alpha", "xi", "quantile"), start = 15,
	end = NA, reverse = FALSE, p = NA, ci = 0.95, autoscale = TRUE, 
	labels = TRUE, \dots)
	
shaparmPlot(x, revert = FALSE, standardize = FALSE, tails = 0.01*(1:10), 
	doplot = <<see below>>, which = <<see below>>, doprint = TRUE, 
	both.tails = TRUE, xi.range = c(0, 10), alpha.range = c(-0.5, 1.5)) 
}


\arguments{


  	\item{x}{[hillPlot][shaparmPlot] -
		the data from which to calculate the shape parameter, a
		numeric vector.
		}

  	\item{autoscale}{[hillPlot] - 
		whether or not plot should be automatically
		scaled; if not, \code{xlim} and \code{ylim} graphical
		parameters may be entered.
		}
  	\item{ci}{[hillPlot] -
		probability for asymptotic confidence band; for no
		confidence band set \code{ci} to zero.
		}
  	\item{labels}{[hillPlot] -
		whether or not axes should be labelled.
		}
	\item{option}{[hillPlot] -
		whether \code{alpha}, \code{xi} (1/alpha) or
		\code{quantile} (a quantile estimate) should be plotted.
		}
  	\item{p}{[hillPlot] -
		probability required when option \code{quantile} is
		chosen.
		}
  	\item{reverse}{[hillPlot] -
		whether plot is to be by increasing threshold, \code{TRUE}, or 
		increasing number of order statistics \code{FALSE}.
		}
	\item{start, end}{[hillPlot] -
		lowest and highest number of order statistics at which to plot
		a point.
		}
  	\item{\dots}{[hillPlot] -
		other graphics parameters.
		}


  	\item{alpha.range, xi.range}{[saparmPlot] - 
		plotting ranges.
		}
 	 \item{both.tails}{[saparmPlot] -
		a logical, decides whether or not both tails should be 
		investigated. By default TRUE. If FALSE only the lower
		tail will be investigated.
		}
  	\item{doplot}{[saparmPlot] - 
		a vector of logicals of the same lengths as tails
		defining for wich tail depths plots should be created,
		by default plots will be generated for a tail depth of 5
		percent. By default \code{c(FALSE, FALSE, FALSE, FALSE, 
		TRUE, FALSE, FALSE, FALSE, FALSE, FALSE)}.
		}
  	\item{doprint}{[saparmPlot] -
		a logical, decides whether or not for all tail depths the
		result for the shape parameter \code{1/alpha} should be
		printed.
		}
	\item{revert}{[saparmPlot] -
		a logical value, by default FALSE, if set to TRUE the
		sign of the vector will be reverted: \code{x = -x}.
		}
  	\item{standardize}{[saparmPlot] -
		a logical value, by default FALSE, if set to 
		TRUE the vector \code{x} will be standardized: 
		\code{x = (x-mean(x))/sqrt(var(x))}.
		}
  	\item{tails}{[saparmPlot] -
		a numeric vector of tail depths to be considered; by
		default ten values ranging from 0.1 to 1.0 in steps of 0.1
		corresponding to values ranging from 1 to 10 percent.
		}
  	\item{which}{[saparmPlot] -	
		a vector of 3 logicals indicating which plots from the 
		three methods will be created. The first entry decides
		for the Pickands estimator, the second for the Hill 
		estimator, and the last for the Deckers-Einmahl-deHaan
		estimator. By default all three will be created.
		By default \code{c(TRUE, TRUE, TRUE)}.
		}

		
}

\value{ 
  
	\code{hillPlot}
	\cr
	displays a plot.
   
  	\code{shaparmPlot} 
  	\cr
  	returns a list with one or two entries, depending on the
  	selection of the input variable \code{both.tails}. The two 
  	entries \code{upper} and \code{lower} determine the position of 
 	the tail. Each of the two variables is again a list with entries 
  	\code{pickands}, \code{hill}, and \code{dehaan}. If one of the 
  	three methods will be discarded the printout will display zeroes.
  	
}


\details{

	\bold{Hill Plot:}
	\cr\cr
	The function \code{hillPlot} investigates the shape parameter and 
	plots the Hill estimate of the tail index of heavy-tailed data, or 
	of an associated quantile estimate. This plot is usually calculated 
	from the alpha perspective. For a generalized Pareto analysis of 
	heavy-tailed data using the \code{gpdFit} function, it helps to 
	plot the Hill estimates for \code{xi}. 
  	\cr
  
  	\bold{Shape Parameter Plot:}
  	\cr\cr
  	The function \code{shaparmPlot} investigates the shape parameter and 
  	plots for the upper and lower tails the shape parameter as a function 
  	of the taildepth. Three approaches are considered, the \emph{Pickands} 
  	estimator, the \emph{Hill} estimator, and the
  	\emph{Decker-Einmal-deHaan} estimator.
  	
  	
}


\author{ 
  
	Alec Stephenson for \R's evir package, \cr
  	Alexander Mcneil for the original EVIS code, \cr
  	Diethelm Wuertz for this \R-port. 
  	
}


\references{

Coles S. (2001);
	\emph{Introduction to Statistical Modelling of Extreme Values},
	Springer.
	
Embrechts, P., Klueppelberg, C., Mikosch, T. (1997);
	\emph{Modelling Extremal Events}, Springer.  
	
}


\seealso{

  	\code{\link{gpdFit}}.
  	
}


\examples{
## hillPlot -
   xmpExtremes("\nStart: Hill Estimator >")
   # Hill plot of heavy-tailed Danish fire insurance data 
   # and BMW stock data for estimated 0.999 quantile
   par(mfrow = c(2, 2))
   data(bmw)
   hillPlot(bmw)
   hillPlot(bmw, option = "quantile", end = 500, p = 0.999)
   data(danish)
   hillPlot(danish)
   hillPlot(danish, option = "quantile", end = 500, p = 0.999)
   
## shaparmPlot -
   xmpExtremes("\nNext: Shape Parameter Plots >")
   par(mfcol = c(3, 2), cex = 0.6)
   data(bmw)
   shaparmPlot(bmw)

## shaparmPlot -
   xmpExtremes("\nNext: Simulated Frechet Data >")
   par(mfcol = c(3, 2), cex = 0.6)
   set.seed(4711)
   x = rgev(10000, xi = 1/4)
   shaparmPlot(x, revert = TRUE, both.tails = FALSE)
   lines(c(0.01, 0.1), c(4, 4), col = "steelblue3") # True Value
}


\keyword{math}


\eof
\name{gpdFamily}

\alias{gpdFamily}

\alias{dgpd}
\alias{pgpd}
\alias{qgpd}
\alias{rgpd}

\title{GPD Distributions for Extreme Value Theory}


\description{

	This is a collection of distribution functions used in extreme 
	value theory. The functions compute density, distribution function, 
	quantile function and generate random deviates for the Generalized 
	Pareto Distribution GPD.
	\cr
	
	The functions are:
	
	\tabular{rll}{
	1 	\tab	\code{dgpd}	
		\tab	Density of the GPD Distribution, \cr
	2 	\tab	\code{pgpd} 	
		\tab	Probability function of the GPD Distribution, \cr
	3 	\tab	\code{qgpd} 	
		\tab	Quantile function of the GPD Distribution, \cr
	4 	\tab	\code{rgpd} 	
		\tab	Random variates from the GPD Distribution. }
	 
}


\usage{
dgpd(x, xi = 1, mu = 0, beta = 1) 
pgpd(q, xi = 1, mu = 0, beta = 1) 
qgpd(p, xi = 1, mu = 0, beta = 1) 
rgpd(n, xi = 1, mu = 0, beta = 1)
}


\arguments{

	\item{n}{
		the number of observations.
		} 
	\item{p}{
		a numeric vector of probabilities.
		}
	\item{q}{
		a numeric vector of quantiles.
		}
  	\item{x}{
		a numeric vector of quantiles.
		}
	\item{xi, mu, beta}{
		\code{xi} is the shape parameter, 
		\code{mu} the location parameter,
		and \code{beta} is the scale parameter.
		}

}


\value{
	
	All values are numeric vectors: \cr
	\code{d*} returns the density, \cr
	\code{p*} returns the probability, \cr
	\code{q*} returns the quantiles, and \cr
	\code{r*} generates random deviates. \cr
}


\details{
	
	\bold{Generalized Pareto Distribution:}
	\cr\cr
	Compute density, distribution function, quantile function and 
	generates random variates for the Generalized Pareto Distribution.
		
}


\author{

	Alec Stephenson for the functions from R's \code{evd} package, \cr
	Diethelm Wuertz for this \R-port.
	
}


\references{

Embrechts, P., Klueppelberg, C., Mikosch, T. (1997);
	\emph{Modelling Extremal Events}, Springer. 
	 
}


\seealso{
  
	\code{\link{gevFit}},
  	\code{\link{gpdFit}}.
  	
}


\examples{
## *gpd  -
   xmpExtremes("\nStart: Simulate GPD Distributed sample >")
   par(mfrow = c(2, 2))
   r = rgpd(n = 1000, xi = 1/4)
   plot(r, type = "l", main="GPD Series")
   
## Plot empirical density and compare with true density:
## Omit values greater than 500 from plot
   xmpExtremes("\nNext: Plot Empirical and True Density >")
   hist(r, n = 50, probability = TRUE, xlab = "r", 
     xlim = c(-5, 5), ylim = c(0, 1.1), main = "Density")
   x = seq(-5, 5, by = 0.01)
   lines(x, dgpd(x, xi = 1/4), col = "steelblue3")
   
## Plot df and compare with true df:
   xmpExtremes("\nNext: Plot Empirical and True Probability >")
   plot(sort(r), (1:length(r)/length(r)), 
     xlim = c(-3, 6), ylim = c(0, 1.1),
   	 cex = 0.5, ylab = "p", xlab = "q", main = "Probability")
   q = seq(-5,5, by=0.1)
   lines(q, pgpd(q, xi = 1/4), col = "steelblue3")
   
## Compute quantiles, a test:
   xmpExtremes("\nNext: Compute Quantiles >")
   qgev(pgev(seq(-5, 5, 0.25), xi = 1/4 ), xi = 1/4) 
}


\keyword{distribution}


\eof
\name{gpdFit}

\alias{gpdFit}
\alias{gpdSim}

\alias{print.gpdFit}
\alias{plot.gpdFit}
\alias{summary.gpdFit}

\alias{gpdqPlot}
\alias{gpdquantPlot}
\alias{gpdriskmeasures}
\alias{gpdsfallPlot}
\alias{gpdshapePlot}
\alias{gpdtailPlot}


\title{Generalized Pareto Distribution Modelling}


\description{
  
	This is a collection of functions to model the Generalized Pareto 
	Distribution, GPD, based on \R's EVIS package. Two approaches
	for parameter estimation are proved: Maximum likelihood estimation
	and the probability weighted moment method.
	\cr
	
	The functions are:
	
	\tabular{rll}{
	 1 	\tab	\code{gpdSim}			
	 	\tab	generates data from the GPD, \cr
	 2 	\tab	\code{gpdFit} 			
	 	\tab	fits empirical or simulated data to the distribution, \cr 
	 3 	\tab	\code{print} 			
	 	\tab	print method for a fitted GPD object of class ..., \cr
  	 4 	\tab	\code{plot} 			
  	 	\tab	plot method for a fitted GPD object, \cr 
  	 5 	\tab	\code{summary} 		
  	 	\tab	summary method for a fitted GPD object, \cr
  	 6 	\tab	\code{gpdqPlot} 		
  	 	\tab	estimation of high quantiles, \cr
  	 7 	\tab	\code{gpdquantPlot} 	
  	 	\tab	variation of high quantiles with threshold, \cr
  	 8 	\tab	\code{gpdriskmeasures} 
  	 	\tab	prescribed quantiles and expected shortfalls, \cr
  	 9 	\tab	\code{gpdsfallPlot} 	
  	 	\tab	expected shortfall with confidence intervals, \cr
  	10 	\tab	\code{gpdshapePlot} 	
  		\tab	variation of shape with threshold, \cr
  	11 	\tab	\code{gpdtailPlot} 	
  		\tab	plot of the tail. }
  	
}


\usage{
gpdSim(model = list(shape = 0.25, location = 0, scale = 1), n = 1000)
gpdFit(x, threshold = NA, nextremes = NA, type = c("mle", "pwm"),
    information = c("observed", "expected"), \dots)

\method{print}{gpdFit}(x, \dots)
\method{plot}{gpdFit}(x, which = "all", \dots)
\method{summary}{gpdFit}(object, doplot = TRUE, which = "all", \dots)

gpdqPlot(x, pp, ci.type = c("likelihood", "wald"), ci.p = 0.95, 
	like.num = 50)
gpdquantPlot(data, p = 0.99, models = 30, start = 15, end = 500, 
	reverse = TRUE, ci = 0.95, autoscale = TRUE, labels = TRUE, \dots)
gpdriskmeasures(x, plevels)
gpdsfallPlot(x, pp, ci.p = 0.95, like.num = 50)
gpdshapePlot(data, models = 30, start = 15, end = 500, reverse = TRUE,
    ci = 0.95, autoscale = TRUE, labels = TRUE, \dots) 
gpdtailPlot(fit, optlog = NA, extend = 1.5, labels = TRUE, \dots)
}


\arguments{

	\item{autoscale}{
	    whether or not plot should be automatically scaled;
	    if not, xlim and ylim graphical parameters may be entered.
	    }     
  	\item{ci}{
	  	the probability for asymptotic confidence band; for no 
	  	confidence band set to zero.
	  	}
	 \item{ci.p}{
	  	the probability for confidence interval (must be less 
	  	than 0.999).
	  	}
  	\item{ci.type}{
	  	the method for calculating a confidence interval: 
	  	\code{"likelihood"} or \code{"wald"}.
	  	}
  	\item{data}{
	  	a numeric vector of data.
	  	}
  	\item{doplot}{
		a logical. Should the results be plotted?
		}
	\item{extend}{
	    optional argument for plots 1 and 2 expressing how far x-axis 
	    should extend as a multiple of the largest data value. This 
	    argument must take values greater than 1 and is useful for
	    showing estimated quantiles beyond data.
	    }
  	\item{fit}{[print][plot][summary] - 
	    print method, a fitted object of class \code{"gpd"}.
	    }
  	\item{information}{
	    whether standard errors should be calculated with
	    \code{"observed"} or \code{"expected"} information. This only applies
	    to the maximum likelihood method; for the probability-weighted moments
	    method \code{"expected"} information is used if possible.
	    }
  	\item{labels}{
	    optional argument for plots 1 and 2  specifying whether or not 
	    axes should be labelled.
	    } 
	\item{like.num}{
	  	the number of times to evaluate profile likelihood.
	  	} 
   	\item{model}{[gpdsim] - 
		a list with components \code{shape}, \code{location} and 
		\code{scale} giving the parameters of the GPD distribution.
		By default the shape parameter has the value 0.25, the
		location is zero and the scale is one.}
  	\item{models}{
	  	the number of consecutive gpd models to be fitted.
	  	}
  	\item{n}{[gpdsim] -
		lnumber of generated data points, an integer value.
		}
  	\item{nextremes}{[gpdFit] - 
	    the number of upper extremes to be used (either this or 
	    \code{threshold} must be given but not both).
	    }
	\item{object}{
  		[summary] -
    	a fitted object of class \code{"gpdFit"}.
    	}
    \item{optlog}{
	    optional argument for plots 1 and 2 giving a particular choice 
	    of logarithmic axes: \code{"x"} x-axis only; \code{"y"} y-axis 
	    only; \code{"xy"} both axes; \code{""} neither axis.
	    }
  	\item{plevels, p, pp}{
	  	a vector of probability levels, the desired probability for the 
	  	quantile estimate (e.g. 0.99 for the 99th percentile).
	  	} 
  	\item{reverse}{
	  	should plot be by increasing threshold (\code{TRUE}) or number 
	  	of extremes (\code{FALSE}).
	  	}
	\item{start, end}{
	  	the lowest and maximum number of exceedances to be considered.
	  	}
	\item{threshold}{
	    a threshold value (either this or \code{nextremes} must be given 
	    but not both).
	    }
  	\item{type}{
	    a character string selecting the desired estimation mehtod, either
	    \code{"mle"} for the maximum likelihood mehtod or \code{"pwm"} for 
	    the probability weighted moment method. By default, the first will 
	    be selected. Note, the function \code{gpd} uses \code{"ml"}.    
		}
	\item{which}{
  		if \code{which} is set to \code{"ask"} the function will 
  		interactively ask which plot should be displayed. By default
  		this value is set to \code{FALSE} and then those plots will
  		be displayed for which the elements in the logical vector
  		\code{which} ar set to \code{TRUE}; by default all four
  		elements are set to \code{"all"}.
  		}
  	\item{x}{[gpdFit] -
	    the data vector. Note, there are two different names
	    for the first argument \code{x} and \code{data} depending 
	    which function name is used, either \code{gpdFit} or the 
	    EVIS synonyme \code{gpd}.
	    \cr
    	[print][plot] -
    	a fitted object of class \code{"gpdFit"}.
	    }
  	\item{\dots}{
	    control parameters and plot parameters optionally passed to the 
	    optimization and/or plot function. Parameters for the optimization
	    function are passed to components of the \code{control} argument of
	    \code{optim}.  
		}
    
}


\value{
  
	\code{gpdSim}
	\cr
	returns a vector of datapoints from the simulated 
	series.
	
	\code{gpdFit} 
	\cr
	returns an object of class \code{"gpd"} describing the 
  	fit including parameter estimates and standard errors. 
  
  	\code{gpdquantPlot}
  	\cr
  	returns invisible a table of results.
  
  	\code{gpdshapePlot}
  	\cr
  	returns invisible a table of results.
  
  	\code{gpdtailPlot}
  	\cr
  	returns invisible a list object containing 
  	details of the plot is returned invisibly. This object should be 
  	used as the first argument of \code{gpdqPlot} or \code{gpdsfallPlot} 
  	to add quantile estimates or expected shortfall estimates to the 
  	plot. 
  	
}


\details{

	\bold{Simulation:}
	\cr\cr
	\code{gpdSim} simulates data from a Generalized Pareto 
  	distribution.
  	\cr
  	
  	\bold{Parameter Estimation:}
  	\cr\cr
  	\code{gpdFit} fits the model parameters either by the probability 
  	weighted moment method or the maxim log likelihood method. 
  	The function returns an object of class \code{"gpd"} 
  	representing the fit of a generalized Pareto model to excesses over 
  	a high threshold. The fitting functions use the probability weighted 
  	moment method, if method \code{method="pwm"} was selected, and the 
  	the general purpose optimization function \code{optim} when the 
  	maximum likelihood estimation, \code{method="mle"} or \code{method="ml"} 
  	is chosen.
  	\cr
  
  	\bold{Methods:}
  	\cr\cr
  	\code{print.gpd}, \code{plot.gpd} and \code{summary.gpd} are print, 
  	plot, and summary methods for a fitted object of class \code{gpdFit}. 
  	The plot method provides four different plots for assessing fitted 
  	GPD model. 
  	\cr
  	
  	\bold{gpd* Functions:}
  	\cr\cr
  	\code{gpdqPlot} calculates quantile estimates and confidence intervals 
  	for high quantiles above the threshold in a GPD analysis, and adds a 
  	graphical representation to an existing plot. The GPD approximation in 
  	the tail is used to estimate quantile. The \code{"wald"} method uses 
  	the observed Fisher information matrix to calculate confidence interval. 
  	The \code{"likelihood"} method reparametrizes the likelihood in terms 
  	of the unknown quantile and uses profile likelihood arguments to 
  	construct a confidence interval. 
    \cr
    
  	\code{gpdquantPlot} creates a plot showing how the estimate of a 
  	high quantile in the tail of a dataset based on the GPD approximation 
  	varies with threshold or number of extremes. For every model 
  	\code{gpdFit} is called. Evaluation may be slow. Confidence intervals 
  	by the Wald method may be fastest.
    \cr
    
  	\code{gpdriskmeasures} makes a rapid calculation of point estimates 
  	of prescribed quantiles and expected shortfalls using the output of the
  	function \code{gpdFit}. This function simply calculates point estimates 
  	and (at present) makes no attempt to calculate confidence intervals for 
  	the risk measures. If confidence levels are required use \code{gpdqPlot} 
  	and \code{gpdsfallPlot} which interact with graphs of the tail of a loss
  	distribution and are much slower.  
    \cr
    
  	\code{gpdsfallPlot} calculates expected shortfall estimates, in other
  	words tail conditional expectation and confidence intervals for high  
  	quantiles above the threshold in a GPD analysis. A graphical 
  	representation to an existing plot is added. Expected shortfall is 
  	the expected size of the loss, given that a particular quantile of the 
  	loss distribution is exceeded. The GPD approximation in the tail is used 
  	to estimate expected shortfall. The likelihood is reparametrised  in 
  	terms of the unknown expected shortfall and profile likelihood arguments 
  	are used to construct a confidence interval. 
    \cr
    
  	\code{gpdshapePlot} creates a plot showing how the estimate of shape 
  	varies with threshold or number of extremes. For every model 
  	\code{gpdFit} is called. Evaluation may be slow.  
  	\cr
  	
  	\code{gpdtailPlot} produces a plot of the tail of the underlying 
  	distribution of the data.
  	
}


\references{

Hosking J.R.M., Wallis J.R., (1987);
	\emph{Parameter and quantile estimation for the generalized
  	Pareto distribution},   
  	Technometrics 29, 339--349.
  	
}


\author{
  
	This function is based on Alec Stephenson's R-package \code{evir} 
  	ported from the \code{EVIS} library, \emph{Extreme Values in S},
  	written by Alexander McNeil. The \code{fExtremes} port and the 
  	change and addition of some functions were done by Diethelm Wuertz.
}


\seealso{
  	
	\code{\link{gevFit}}.
	
} 

  
\examples{
## Load Data:
   data(danish)
   data(bmw)
   
## Simulate GPD Data:
   xmpExtremes("\nStart: Simulate a GPD Distributed Sample > ")
   x = gpdSim(model = list(shape = 0.25, location = 0, scale = 1), n = 1000)
   # Fit GPD Data by Probability Weighted Moments:
   fit = gpdFit(x, nextremes = length(x), type = "pwm") 
   print(fit)
   # Summarize Results:
   par(mfcol = c(4, 2), cex = 0.5)
   summary(fit)  
   
## Fit GPD Data by Max Log Likelihood Method:
   xmpExtremes("\nNext: Estimate Parameters > ")
   fit = gpdFit(x, nextremes = length(x), type = "mle") 
   print(fit)
   # Summarize Results:
   summary(fit) 

## Fit GPD to excess losses over 10 for the 
   xmpExtremes("\nNext: Fit to Excess Losses > ")
   # Danish Fire insurance data:
   fit = gpdFit(danish, 10, type = "mle") 
   print(fit)
   par(mfrow = c(2, 2), cex = 0.7)
   summary(fit)  
   
## Make Example Function:
   xmpExtremes("\nNext: Write Example Function > ")
   examples = function(n) {
     par(mfrow = c(2, 2), cex = 0.7)
   
## gpdqPlot - 
   # Estimate 99.5th percentile:
   # BMW Stock Data: 
     par(mfrow = c(2, 2), cex = 0.7)
     plot(-bmw, ylim = c(0, 0.25), type = "h", main = "BMW Stock Data")
     fit = gpdFit(-bmw, nextremes = floor(length(bmw)/10), type = "mle")
     tail = gpdtailPlot(fit)
     gpdqPlot(tail, 0.995)
     title(main = "BMW: 99.5th Percentile")
 
## gpdqPlot - 
   # Estimates 0f the 99.5th percentile 
   # Danish Fire Data:
     fit = gpdFit(danish, threshold = 10, type = "mle")
     tail = gpdtailPlot(fit)
     gpdqPlot(tail, 0.995)
     title(main = "Danish Data: 99.5th Percentile") }

## gpdquantPlot - 
   # Estimates of the 99.9th percentile:
   # BMW Stock Data
     plot(-bmw, ylim = c(0, 0.25), type = "h", main = "BMW Stock Data")
     gpdquantPlot(-bmw, p = 0.999)
     title(sub = "BMW: GPD High Quantile", cex.sub = 0.75)

## gpdquantPlot - 
   # Estimates of the 99.9th percentile:
   # Danish Fire Data:
     plot(danish, type = "h", main = "Danish Fire")
     gpdquantPlot(danish, p=0.999)
     title(sub = "Danish Fire: GPD High Quantile", cex.sub = 0.75) 
   } # End of Example Function

## gpdsfallPlot - 
   # Calculate expected shortfall:
   # BMW Stock Data:
   ##> plot(-bmw, ylim = c(0, 0.25), type = "h", main = "BMW Stock Data")
   ##> fit = gpdFit(bmw, nextremes = floor(length(bmw)/10), type = "mle")
   ##> tp = gpdtailPlot(fit)
   ##> gpdsfallPlot(tp, 0.999)   
   ##> title(main="BMW: Expected Shortfall") 

## gpdsfallPlot - 
   # Calculate expected shortfall:
   # Danish Fire Data:
   ##> plot(danish, type = "h", main = "Danish Fire Data")
   ##> fit = gpdFit(danish, nextremes = floor(length(danish)/10), type = "mle")
   ##> tp = gpdtailPlot(fit)
   ##> gpdsfallPlot(tp, 0.999)   
   ##> title(main = "Danish Fire: Expected Shortfall") }    

## Calculate Quantiles and Expected Shortfalls:
   xmpExtremes("\nNext: Quantiles and Expected Shortfall > ")
   # Give estimates of 0.999 and 0.9999 quantiles:
   # BMW Stock Data:  
   fit = gpdFit(-bmw, nextremes = floor(length(bmw)/10), type = "mle") 
   gpdriskmeasures(fit, c(0.99, 0.995, 0.999, 0.9995, 0.9999)) 
   
## Calculate Quantiles and Expected Shortfalls:
   xmpExtremes("\nNext: Quantile Estimates > ")
   # Give estimates of 0.999 and 0.9999 quantiles:
   # Danish Fire Date:   
   fit = gpdFit(danish, threshold = 10, type = "mle") 
   gpdriskmeasures(fit, c(0.99, 0.995, 0.999, 0.9995, 0.9999))   
  
## gpdshapePlot - 
   xmpExtremes("\nNext: Shape Plot of Heavy-Tailed Data > ")
   # Simulated GPD Data:
   set.seed(4711)
   x = gpdSim(n = 1000)
   plot(x, type = "h", main = "Simulated GPD Data")
   gpdshapePlot(x)
   title(sub = "Simulated GPD", cex.sub = 0.75)   

## gpdshapePlot - 
   xmpExtremes("\nNext: Shape Plot of Heavy-Tailed Data > ")
   # Danish Fire Data:
   plot(danish, type = "h", main = "Danish Fire Data")
   gpdshapePlot(danish)
   title(sub = "Danish Fire", cex.sub = 0.75) }   
   xmpExtremes("Press any key to continue > ")

## gpdtailPlot - 
   xmpExtremes("\nNext: Plot Tail Estimate >")
   # BMW Stock Data:
   plot(-bmw, ylim = c(0, 0.25), type = "h", main = "BMW Stock Data")
   fit = gpdFit(-bmw, nextremes=floor(length(bmw)/10), type = "mle")
   gpdtailPlot(fit, main = "Simulated GPD: GPD Tail Estimate") 

## gpdtailPlot - 
   xmpExtremes("\nNext: Plot Tail Estimate >")
   # Danish Fire Data:
   plot(danish, type = "h", main = "Danish Fire Data")
   fit = gpdFit(danish, threshold = 10, type = "mle") 
   gpdtailPlot(fit, main = "Danish Fire: GPD Tail Estimate")  
}


\keyword{models}


\eof
\name{gpdglmFit}

\alias{gpdglmFit}

\alias{print.gpdglmFit}
\alias{plot.gpdglmFit}
\alias{summary.gpdglmFit}

\alias{gpdglmprofPlot}
\alias{gpdglmprofxiPlot}


\title{Maximum-likelihood Fitting for the GPD Model}


\description{
  
	This is a collection of functions to model the Generalized Pareto 
	Distribution, GPD, by maximum likelihood approximation based 
	on \R's ISMEV package. In addition to \code{gpdFit} the parameter 
	estimation allows to include generalized linear modelling of each 
	parameter, therefore the name \code{gpdglmFit}.
	\cr
	
	The functions are:
	
	\tabular{rll}{
	1 	\tab	\code{gpdglmFit}			
		\tab	fits empirical or simulated data to the distribution, \cr 
  	2 	\tab	\code{print} 				
  		\tab	print method for a fitted GPD object of class ..., \cr
  	3 	\tab	\code{plot} 				
  		\tab	plot method for a fitted GPD object, \cr 
  	4 	\tab	\code{summary} 			
  		\tab	summary method for a fitted GPD object, \cr 	
  	5 	\tab	\code{gpdglmprofPlot} 		
  		\tab	profile log-likelihoods for return levels, \cr 
  	6 	\tab	\code{gpdglmprofxiPlot} 	
  		\tab	profile log-likelihoods for shape parameters. }
  	
}


\usage{
gpdglmFit(x, threshold = min(x), npy = 365, y = NULL, sigl = NULL,
    shl = NULL, siglink = identity, shlink = identity, show = FALSE,
    method = "Nelder-Mead", maxit = 10000, \dots)

\method{print}{gpdglmFit}(x, \dots)
\method{plot}{gpdglmFit}(x, which = "all", \dots)
\method{summary}{gpdglmFit}(object, doplot = TRUE, which = "all", \dots)

gpdglmprofPlot(fit, m, xlow, xup, conf = 0.95, nint = 100, \dots)
gpdglmprofxiPlot(fit, xlow, xup, conf = 0.95, nint = 100, \dots)
}


\arguments{

  	\item{conf}{
  		[gpdglmprof*Plot] -
	    the confidence coefficient of the plotted profile confidence 
	    interval.
	    }
	\item{doplot}{
		a logical. Should the results be plotted?
		}
	\item{fit}{
	    a fitted object either of class \code{"gpdglm"}.
	    }    
    \item{m}{
    	[gpdglmprof*Plot] -
	    the return level; i.e. the profile likelihood is for the value 
	    that is exceeded with probability 1/\code{m}.
	    }
	\item{maxit}{
		[gpdglmFit] -
	    the maximum number of iterations.
	    }
	\item{method}{
		[gpdglmFit] -
	    the optimization method; see \code{\link{optim}} for
	    details.
	    }
  	\item{nint}{
  		[gpdglmprof*Plot] -
	    the number of points at which the profile likelihood is evaluated.
	    }   
	\item{npy}{
		[gpdglmFit] -
	    the number of observations per year/block. By default 365.
	    }
  	\item{object}{
  		[summary] -
    	a fitted object of class \code{"gpdglmFit"}.
    	}
    \item{show}{
    	[gpdglmFit] -
	    a logical; if \code{TRUE} (the default), print details of
	    the fit.
	    }
  	\item{sigl, shl}{
  		[gpdglmFit] -
	    numeric vectors of integers, giving the columns
	    of \code{ydat} that contain covariates for generalized linear
	    modelling of the scale and shape parameters repectively
	    (or \code{NULL} (the default) if the corresponding parameter is
	    stationary).
	    }
  	\item{siglink, shlink}{
  		[gpdglmFit] -
	    inverse link functions for generalized
	    linear modelling of the scale and shape parameters repectively.
	    }
	\item{threshold}{
		[gpdglmFit] -
	    the threshold value; a single number or a numeric
	    vector of the same length as \code{xdat}.
	    }
  	\item{which}{
  		[plot][summary] - 
	    a vector of logicals, one for each plot, denoting which plot 
	    should be displayed. By default \code{c(TRUE, TRUE, TRUE, TRUE, 
	    TRUE)}.
	    }
	\item{x}{
	    A numeric vector of data to be fitted.
	    \cr
    	[print][plot] -
    	a fitted object of class \code{"gpdglmFit"}.
	    }
	\item{xlow, xup}{[gpdglmprof*Plot] -
	    the least and greatest value at which to evaluate the profile 
	    likelihood.
	    }
	\item{y}{
		[gpdglmFit] -
	    a matrix of covariates for generalized linear modelling
	    of the parameters (or \code{NULL} (the default) for stationary
	    fitting). The number of rows should be the same as the length
	    of \code{xdat}.
	    }
  	\item{\dots}{
  		[gpdglmFit] -
    	other control parameters for the optimization. These are passed
    	to components of the \code{control} argument of \code{optim}.
    	}  
      
}


\value{
  
	A list containing the following components. A subset of these
  	components are printed after the fit. If \code{show} is
  	\code{TRUE}, then assuming that successful convergence is
  	indicated, the components \code{nexc}, \code{nllh},
  	\code{mle}, \code{rate} and \code{se} are always printed.
  
  	\item{trans}{
    	An logical indicator for a non-stationary fit.
    	}
  	\item{model}{
   		A list with components \code{sigl} and \code{shl}.
   		}
  	\item{link}{
    	A character vector giving inverse link functions.
    	}
  	\item{threshold}{
    	The threshold, or vector of thresholds.
    	}
  	\item{nexc}{
    	The number of data points above the threshold.
    	}
  	\item{data}{
    	The data that lie above the threshold. For
    	non-stationary models, the data is standardized.
    	}
  	\item{conv}{
    	The convergence code, taken from the list returned by
    	\code{\link{optim}}. A zero indicates successful convergence.
    	}
  	\item{nllh}{
    	The negative logarithm of the likelihood evaluated at
    	the maximum likelihood estimates.
    	}
  	\item{vals}{
    	A matrix with three columns containing the maximum
    	likelihood estimates of the scale and shape parameters, and
    	the threshold, at each data point.
    	} 
  	\item{mle}{
   	 	A vector containing the maximum likelihood estimates.
   	 	}
  	\item{rate}{
	    The proportion of data points that lie above the
	    threshold.
	    }
  	\item{cov}{
    	he covariance matrix.
    	}
  	\item{se}{
    	A vector containing the standard errors.
    	}
  	\item{n}{
	    The number of data points (i.e.\ the length of
	    \code{xdat}).
	    }
  	\item{npy}{
    	The number of observations per year/block.
    	}
  	\item{xdata}{
    	The data that has been fitted.
    	} 
    
  	For stationary models four plots are produced; a probability
  	plot, a quantile plot, a return level plot and a histogram
  	of data with fitted density. For non-stationary models two plots 
  	are produced; a residual probability plot and a residual quantile 
  	plot.
    
}


\details{
  
	\bold{Simulation:}
	\cr\cr
	To simulate a GPD series use the function \code{gpdSim}.
	\cr
	
	\bold{Parameter Estimation:}
	\cr\cr
	\code{gpdglmFit} fits by the Maximum-likelihood approach the generalized 
  	extreme value distribution, including generalized linear modelling 
  	of each parameter. 
  	\cr
  
  	\bold{Methods:}
  	\cr\cr
  	\code{print.gpdglm}, \code{plot.gpdglm} and \code{summary.gpdglm} 
  	are print, plot, and summary methods for a fitted object of class 
  	\code{gpdglm}.
  	\cr
  
  	\bold{Nonstationary Models:}
  	\cr\cr
  	For non-stationary fitting it is recommended that the covariates
  	within the generalized linear models are (at least approximately)
  	centered and scaled (i.e.\ the columns of \code{ydat} should be
  	approximately centered and scaled).
  	
}


\author{
  
	Alec Stephenson for the code implemented from \R's ismev package, \cr
	Stuart Scott for the original code, and
	Diethelm Wuertz for this \R-port.
  	
}


\references{

Coles S. (2001);
	\emph{Introduction to Statistical Modelling of Extreme Values},
	Springer.  
	
}


\seealso{
  
  	\code{\link{mrlPlot}}, 
  	\code{\link{ppFit}}.
  	
}


\examples{
## Use Rain Data:
   data(rain)
   
## Fit GPD Model:
   xmpExtremes("Start: Parameter Estimation >")
   fit = gpdglmFit(x = rain, threshold = 10)
   print(fit)
   xmpExtremes("Next: Summary Report > ")
   
## Summarize Results:
   xmpExtremes("Next: Profile Likelihood >")
   par(mfrow = c(2, 2), cex = 0.75)
   summary(fit, which = "all")
   # Profile Lielihood:
   par(mfrow = c(2, 1), cex = 0.75)
   gpdglmprofPlot(fit, m = 10, xlow = 55, xup = 75)
   title(main = "Rain")
   gpdglmprofxiPlot(fit, xlow = -0.02, 0.15)
   title(main = "Rain")
}


\keyword{models}


\eof
\name{potFit}


\alias{potSim}
\alias{potFit}

\alias{print.potFit}
\alias{plot.potFit}
\alias{summary.potFit}

\title{Peaks Over Thresholds Model}


\description{
  
	This is a collection of functions to model point processes over
	a threshold, POT, based on \R's \code{evir} package. 
	\cr
	
	The functions are:
	
	\tabular{rll}{
	1 	\tab	\code{potSim} 			
		\tab	generates data from a point process, \cr
	2 	\tab	\code{potFit} 			
		\tab	fits empirical or simulated data to a point process, \cr 
  	3 	\tab	\code{print} 			
  		\tab	print method for a fitted POT object of class ..., \cr
  	4 	\tab	\code{plot} 			
  		\tab	plot method for a fitted GEV object, \cr 
  	5 	\tab	\code{summary} 		
  		\tab	summary method for a fitted GEV object, \cr	
  	6 	\tab	\code{gevrlevelPlot} 	
  		\tab	k-block return level with confidence intervals. }
  
}


\usage{
potSim(x, threshold, nextremes = NA, run = NA)
potFit(x, threshold = NA, nextremes = NA, run = NA, \dots) 

\method{print}{potFit}(x, \dots)
\method{plot}{potFit}(x, which = "all", \dots)
\method{summary}{potFit}(object, doplot = TRUE, which  = "all", \dots)
}


\arguments{


  	\item{doplot}{
		a logical. Should the results be plotted?
		}
  	\item{nextremes}{
	    the number of upper extremes to be used (either
	    this or \code{threshold} must be given but not both).
	    }
  	\item{object}{
  		[summary] -
    	a fitted object of class \code{"potFit"}.
    	}
    \item{run}{
	    if the data are to be declustered the run length parameter for 
	    the runs method, see \code{\link{deCluster}}, should be entered 
	    here.
		}
	\item{threshold}{
	    a threshold value, either \code{threshold} or \code{nextremes}
	    must be given, but not both).
	    }
  	\item{which}{
  		if \code{which} is set to \code{ask} the function will 
  		interactively ask which plot should be displayed. By default
  		this value is set to \code{FALSE} and then those plots will
  		be displayed for which the elements in the logical vector
  		\code{which} ar set to \code{TRUE}; by default all four
  		elements are set to \code{"all"}.
  		}
  	\item{x}{
	    numeric vector of data, which may have a \code{times} attribute 
	    containing (in an object of class \code{"POSIXct"}, or an object 
	    that can be converted to that class; see \code{\link{as.POSIXct}}) 
	    the times/dates of each observation.
	    If no \code{times} attribute exists, the data are assumed to be
	    equally spaced. Note, the argument name is different for 
	    \code{potFit} and \code{pot}.
	    \cr
    	[print][plot] -
    	a fitted object of class \code{"potFit"}.
	    }
	\item{\dots}{
	    control parameters and plot parameters optionally passed to the 
	    optimization and/or plot function. Parameters for the optimization
	    function are passed to components of the \code{control} argument 
	    of \code{optim}.
	    }  
      
}


\value{
  
	Both, \code{potFit} and \code{pot} return an object of class \code{"pot"}
  	describing the fit including parameter estimates and standard errors. 

}


\details{
  
	\bold{Parameter Estimation:}
	\cr\cr
	\code{potFit} uses \code{optim} for point process likelihood 
  	maximization. 
  	\cr
  
  	\bold{Methods:}
  	\cr\cr
  	The plot method \code{plot.pot} provides seven different plots for 
  	assessing fitted POT model. The user selects the plot type from a 
  	menu. Plot 1 displays the exceedance process of the chosen threshold. 
  	Plots 2-4  assess the Poisson nature of the exceedance process 
  	by looking at the scaled gaps between exceedances, which should
  	be iid unit exponentially distributed. Plots 5-6 assess the GPD
  	nature of the excesses by looking at suitably defined residuals,
  	which should again be iid unit exponentially distributed. Option
  	8 allows the user to call GPD plotting functions. If plot 1 or 2 
  	from the GPD plots is selected as the final plot (i.e. option 8 is 
  	selected, followed by option 1 or 2), a list object containing 
  	details of the plot is returned invisibly. This object should be 
  	used as the first argument of \code{gpdqPlot} or \code{gpdsfallPlot} 
  	to add quantile estimates or expected shortfall estimates to the plot.
}


\seealso{
  
	\code{\link{gpdFit}}, 
  	\code{\link{deCluster}}.
}

  
\examples{
## Use Danish Fire Insurance Loss Data:
   data(danish)
   
## Fit:
   xmpExtremes("\nStart: POT Parameter Estimate >")
   fit = potFit(danish, threshold = 10)  
   print(fit)
   
## Summary with Diagnostic Plots:
   xmpExtremes("\nNext: Diagnostic Analysis >")
   par(mfrow = c(3, 3), cex = 0.5)
   summary(fit)
}


\keyword{models}

\eof
\name{ppFit}

\alias{ppFit}

\alias{print.ppFit}
\alias{plot.ppFit}
\alias{summary.ppFit}

\title{Maximum-likelihood Fitting for the Point Process Model}


\description{

	This is a collection of functions to model point processes, PP,
	over a threshold, based on \R's \code{ismev} package. The parameter 
	estimation allows to include generalized linear modelling of 
	each parameter.
	\cr
	
	The functions are:
	
	\tabular{rll}{
	1 	\tab	\code{potSim} 			
		\tab	generates data from a point process, \cr
	2 	\tab	\code{potFit} 			
		\tab	fits empirical or simulated data to a point process, \cr 
  	3 	\tab	\code{print} 			
  		\tab	print method for a fitted POT object of class ..., \cr
  	4 	\tab	\code{plot} 			
  		\tab	plot method for a fitted GEV object, \cr 
  	5 	\tab	\code{summary} 		
  		\tab	summary method for a fitted GEV object, \cr 	
  	6 	\tab	\code{gevrlevelPlot} 	
  		\tab	k-block return level with confidence intervals. }
  	
}


\usage{
ppFit(x, threshold, npy = 365, y = NULL, mul = NULL, sigl = NULL, 
	shl = NULL, mulink = identity, siglink = identity, shlink =
    identity, method = "Nelder-Mead", maxit = 10000, \dots)

\method{print}{ppFit}(x, \dots)
\method{plot}{ppFit}(x, which = "ask", \dots)
\method{summary}{ppFit}(object, doplot = TRUE, which = "all", \dots)
}


\arguments{

  	\item{doplot}{
		a logical. Should the results be plotted?
		}
  	\item{maxit}{
  		[ppFit] -
	    the maximum number of iterations.
	    }
	\item{method}{
		[ppFit] -
	    The optimization method (see \code{\link{optim}} for details).
	    }
	\item{mul, sigl, shl}{
		[ppFit] -
	    numeric vectors of integers, giving the columns
	    of \code{ydat} that contain covariates for generalized linear
	    modelling of the location, scale and shape parameters repectively
	    (or \code{NULL} (the default) if the corresponding parameter is
	    stationary).
	    }
  	\item{mulink, siglink, shlink}{
  		[ppFit] -
	    inverse link functions for generalized
	    linear modelling of the location, scale and shape parameters
	    repectively.
	    }
  	\item{npy}{
  		[ppFit] -
	    the number of observations per year/block.
	    }
  	\item{object}{
  		[summary] -
    	a fitted object of class \code{"ppFit"}.
    	}
  	\item{threshold}{
  		[ppFit] -
    	the threshold; a single number or a numeric
	    vector of the same length as \code{x}.
	    }
  	\item{which}{
  		[print][plot][summary] -
    	a logical for each plot, denoting which plots should be created.
    	}
    \item{x}{
      	[ppFit] -
	    a numeric vector of data to be fitted.
	    \cr
    	[print][plot] -
    	a fitted object of class \code{"ppFit"}.
		}
	\item{y}{
		[ppFit] -
	    a matrix of covariates for generalized linear modelling
	    of the parameters (or \code{NULL} (the default) for stationary
	    fitting). The number of rows should be the same as the length
	    of \code{x}.
	    }
	\item{\dots}{
		[ppFit] -
	    control parameters and plot parameters optionally passed to the 
	    optimization and/or plot function. Parameters for the optimization
	    function are passed to components of the \code{control} argument of
	    \code{optim}.
	    }     
        
}


\value{

  	A list containing the following components. A subset of these
  	components are printed after the fit. If \code{show} is
  	\code{TRUE}, then assuming that successful convergence is
  	indicated, the components \code{nexc}, \code{nllh}, \code{mle}
  	and \code{se} are always printed.
  
  	\item{trans}{
	    An logical indicator for a non-stationary fit.
	    }
  	\item{model}{
	    A list with components \code{mul}, \code{sigl}
	    and \code{shl}.
	    }
  	\item{link}{
    	A character vector giving inverse link functions.
    	}
  	\item{threshold}{
	    The threshold, or vector of thresholds.
	    }
  	\item{npy}{
	    The number of observations per year/block.
	    }
  	\item{nexc}{
	    The number of data points above the threshold.
	    }
  	\item{data}{
	    The data that lie above the threshold. For
	    non-stationary models, the data is standardized.
	    }
  	\item{conv}{
	    The convergence code, taken from the list returned by
	    \code{\link{optim}}. A zero indicates successful convergence.
	    }
  	\item{nllh}{
	    The negative logarithm of the likelihood evaluated at
	    the maximum likelihood estimates.
	    }
  	\item{vals}{
	    A matrix with four columns containing the maximum
	    likelihood estimates of the location, scale and shape
	    parameters, and the threshold, at each data point.
	    }
  	\item{gpd}{
	    A matrix with three rows containing the maximum
	    likelihood estimates of corresponding GPD location, scale
	    and shape parameters at each data point.
	    }
  	\item{mle}{
	    A vector containing the maximum likelihood estimates.
	    }
  	\item{cov}{
	    The covariance matrix.
	    }
  	\item{se}{
	    A vector containing the standard errors.
	    }
    
  	For stationary models two plots are produced; a probability plot 
  	and a quantile plot. For non-stationary models two plots are produced; 
  	a residual probability plot and a residual quantile plot.
  	
}


\details{
  
	For non-stationary fitting it is recommended that the covariates
  	within the generalized linear models are (at least approximately)
  	centered and scaled (i.e.\ the columns of \code{ydat} should be
  	approximately centered and scaled).
  
}


\author{
  
	Alec Stephenson for the code implemented from \R's ismev package, \cr
	Stuart Scott for the original code, and
	Diethelm Wuertz for this \R-port.
  	
}


\references{

Coles S. (2001);
	\emph{Introduction to Statistical Modelling of Extreme Values},
	Springer. 
	 
}


\seealso{

  \code{\link{mrlPlot}},
  \code{\link{gpdFit}}.
  
}

  
\examples{
## Use Rain Data:
   data(rain)
   
## Fit Point Process Model:
   xmpExtremes("Start: Parameter Fit for Point Process > ")
   fit = ppFit(x = rain[1:200], threshold = 10)
   print(fit) 
   
## Summarize Results:
   xmpExtremes("Next: Diagnostic Analysis > ")
   par(mfrow = c(2, 2), cex = 0.75)
   summary(fit)
   xmpExtremes("Next: Interactive Plot > ")
   
## Interactive Plot:
   ##> par(mfrow = c(2, 2), cex = 0.75)
   ##> plot(fit)
}


\keyword{models}


\eof
\name{rlargFit}

\alias{rlargFit}

\alias{print.rlargFit}
\alias{plot.rlargFit}
\alias{summary.rlargFit}

\title{Maximum-likelihood Fitting of Order Statistics Model}


\description{
  
	This is a collection of functions to model the Order Statistic
	Model by maximum likelihood approximation based 
	on \R's ISMEV package. The parameter 
	estimation allows to include generalized linear modelling of each 
	parameter.
	\cr
	
	The functions are:
	
	\tabular{rll}{
	1 	\tab	\code{gpdglmFit}			
		\tab	fits empirical or simulated data to the distribution, \cr 
  	2 	\tab	\code{print}				
  		\tab	print method for a fitted GPD object of class ..., \cr
  	3 	\tab	\code{plot} 				
  		\tab	plot method for a fitted GPD object, \cr 
  	4 	\tab	\code{summary} 			
  		\tab	summary method for a fitted GPD object, \cr
  	5 	\tab	\code{gevglmprofPlot} 		
  		\tab	profile log-likelihoods for return levels, \cr 
  	6 	\tab	\code{gevglmprofxiPlot} 	
  		\tab	profile log-likelihoods for shape parameters. }
  	
}


\usage{
rlargFit(x, r = dim(x)[2], y = NULL, mul = NULL, sigl = NULL,
  	shl = NULL, mulink = identity, siglink = identity, shlink = identity,
  	method = "Nelder-Mead", maxit = 10000, \dots)

\method{print}{rlargFit}(x, \dots)
\method{plot}{rlargFit}(x, which = "all", \dots)
\method{summary}{rlargFit}(object, doplot = TRUE, which = "all", \dots)
}


\arguments{

  	\item{doplot}{
		a logical. Should the results be plotted?
		}
	\item{maxit}{
		[rlargFit] -
	    the maximum number of iterations.
	    }
  	\item{method}{[rlargFit] -
	    the optimization method (see \code{\link{optim}} for details).
	    }
  	\item{mul, sigl, shl}{[rlargFit] -
	    numeric vectors of integers, giving the columns
	    of \code{ydat} that contain covariates for generalized linear
	    modelling of the location, scale and shape parameters repectively
	    (or \code{NULL} (the default) if the corresponding parameter is
	    stationary).
	    }
  	\item{mulink, siglink, shlink}{
  		[rlargFit] -
	    inverse link functions for generalized linear modelling of the 
	    location, scale and shape parameters repectively.
	    }
	\item{object}{
  		[summary] -
    	a fitted object of class \code{"rlargFit"}.
    	}
    \item{r}{
		[rlargFit] -
	    the largest \code{r} order statistics are used for the fitted model.
	    }
  	\item{x}{
  		[rlargFit] -
	    a numeric matrix of data to be fitted. Each row should be a vector 
	    of decreasing order, containing the largest order statistics for 
	    each year (or time period). The first column therefore contains annual 
	    (or period) maxima.
	    Only the first \code{r} columns are used for the fitted model. By 
	    default, all columns are used.
	    If one year (or time period) contains fewer order statistics than 
	    another, missing values can be appended to the end of the 
	    corresponding row.
	    \cr
    	[print][plot] -
    	a fitted object of class \code{"rlargFit"}.
    	}
	\item{y}{
		[rlargFit] -
	    A matrix of covariates for generalized linear modelling of the 
	    parameters (or \code{NULL} (the default) for stationary fitting). 
	    The number of rows should be the same as the number of rows of 
	    \code{x}.
	    }
	\item{which}{
  		[print][plot][summary] -
    	a logical for each plot, denoting which plots should be created.
    	}
	\item{\dots}{
		[rlargFit][plot] - 
	    control parameters and plot parameters optionally passed to the 
	    optimization and/or plot function. Parameters for the optimization
	    function are passed to components of the \code{control} argument of
	    \code{optim}.
	    }   
    
}


\details{
  
	For non-stationary fitting it is recommended that the covariates
  	within the generalized linear models are (at least approximately)
  	centered and scaled (i.e.\ the columns of \code{ydat} should be
  	approximately centered and scaled).
  	
}


\value{
  
	A list containing the following components. A subset of these
  	components are printed after the fit. If \code{show} is
  	\code{TRUE}, then assuming that successful convergence is
  	indicated, the components \code{nllh}, \code{mle} and \code{se}
  	are always printed.
  
  	\item{trans}{
	    An logical indicator for a non-stationary fit.
	    }
  	\item{model}{
	    A list with components \code{mul}, \code{sigl} and \code{shl}.
	    }
  	\item{link}{
	    A character vector giving inverse link functions.
	    }
  	\item{conv}{
	    The convergence code, taken from the list returned by
	    \code{\link{optim}}. A zero indicates successful convergence.
	    }
  	\item{nllh}{
	    The negative logarithm of the likelihood evaluated at
	    the maximum likelihood estimates.
	    }
  	\item{data}{
	    The data that has been fitted. For non-stationary
	    models, the data is standardized.
	    }
  	\item{mle}{
	    A vector containing the maximum likelihood estimates.
	    }
  	\item{cov}{
	    The covariance matrix.
	    }
  	\item{se}{
    	A vector containing the standard errors.}
  	\item{vals}{
	    A matrix with three columns containing the maximum
	    likelihood estimates of the location, scale and shape parameters
	    at each data point.
	    }
  	\item{r}{
	    The number of order statistics used.
	    }
    
  	For stationary models four plots are initially produced;
  	a probability plot, a quantile plot, a return level plot
  	and a histogram of data with fitted density.
  	Then probability and quantile plots are produced for the
  	largest \code{n} order statistics. For non-stationary models 
  	residual probability plots and residual quantile plots are 
  	produced for the largest \code{n} order statistics.
    
}


\author{
  
	Alec Stephenson for the code implemented from \R's ismev package, \cr
	Stuart Scott for the original code, and
	Diethelm Wuertz for this \R-port.
  	
}


\references{

Coles S. (2001);
	\emph{Introduction to Statistical Modelling of Extreme Values},
	Springer.  
	
}


\seealso{
  
	\code{\link{ppFit}},
  	\code{\link{potFit}}.
  	
}


\examples{
## Use Venice Data:
   data(venice)
   
## Fit for the order statistic model:
   xmpExtremes("Start: Parameter Fit for Order Statistics Model > ")
   fit = rlargFit(venice[, 2:4], r = 3)
   fit
   
## Summarize Results:
   xmpExtremes("Next: Diagnostic Analysis > ")
   summary(fit) 
}


\keyword{models}


\eof
\name{exindexPlots}

\alias{exindexPlots}

\alias{exindexPlot}
\alias{exindexesPlot}

\title{Extremal Index Estimation}


\description{
  
	This is a collection of functions to compute the extremal 
    index three different kind of methods, the blocks method, 
    the reciprocal mean cluster size method, and the runs
    method. 
	\cr
	
	The functiona are:
	
	\tabular{rll}{
	1	\tab	\code{exindexPlot}		
		\tab	Calculate and Plot Theta(1,2,3), \cr
	2	\tab	\code{exindexesPlot}	
		\tab	Calculate Theta(1,2) and Plot Theta(1). }
  	
}


\usage{
exindexPlot(x, block = "month", start = 5, end = NA, plottype = c("thresh", 
    "K"), labels = TRUE, autoscale = TRUE, \dots)
    
exindexesPlot(x, block = 20, quantiles = seq(0.990, 0.999, 0.001), 
	doplot = TRUE, \dots)
}


\arguments{

  	\item{autoscale}{[exindexPlot] -
	    whether or not plot should be automatically scaled; if not, 
	    \code{xlim} and \code{ylim} graphical parameters may be entered.
	    }
	\item{block}{
	    the block size. A numeric value is interpreted as the number of 
	    data values in each successive block.
	    All the data is used, so the last block may not contain \code{block} 
	    observations.
	    If the \code{x} has a \code{times} attribute containing (in an 
	    object of class \code{"POSIXct"}, or an object that can be
	    converted to that class; see \code{\link{as.POSIXct}}) the
	    times/dates of each observation, then \code{block} may instead
	    take the character values \code{"month"}, \code{"quarter"},
	    \code{"semester"} or \code{"year"}.
	    Note, \code{exindexPlot} supports both numeric and character input,
	    \code{exindexPlot} supports only numeric input.
	    By default, monthly blocks or 20-day blocks are used which are 
	    thought for daily data records.
	    }
  	\item{doplot}{[exindexesPlot] -
	    a logical, should the results be plotted?
	    }
	\item{labels}{[exindexPlot] -
	    whether or not axes should be labelled.
	    }
	\item{plottype}{[exindexPlot] -
	    whether plot is to be by increasing threshold (\code{thresh}) 
	    or increasing K value (\code{K}).
	    }
	\item{quantiles}{[exindexesPlot] -
	    a numeric vector of quantile values.
	    }
	\item{start, end}{[exindexPlot] -
	    \code{start} is the lowest value of \code{K} at which to plot 
	    a point, and \code{end} the highest value; \code{K} is the
	    number of blocks in which a specified threshold is exceeded.
	    }
 	\item{x}{
	    a numeric vector, note raw values are required, not block maxima.
	    }
	\item{\dots}{
	    additional arguments passed to the plot function.
	    }
	    
}


\value{
  
	\code{exindexPlot}
	\cr
	returns a data frame of results with the 
	following columns: \code{N}, \code{K}, \code{un}, \code{theta2},
	and \code{theta}. A plot with \code{K} on the lower x-axis and
	threshold Values on the upper x-axis versus the extremal index
	is displayed.
  
  	\code{exindexesPlot}
  	\cr
  	returns a data.frame with four columns: 
  	\code{thresholds}, \code{theta1}, \code{theta2}, and \code{theta3}.
  	A plot with quantiles on the x-axis and versus the extremal indexes
	is displayed.
  	
}


\authors{

	Alexander McNeil, for the \code{exindexPlot} function, and \cr
	Diethelm Wuertz for the \code{exindexesPlot} function.
	
}


\references{

Embrechts, P., Klueppelberg, C., Mikosch, T. (1997);
  	\emph{Modelling Extremal Events}, 
  	Springer. Chapter 8, 413--429.  
  	
}


\seealso{
  
  	\code{\link{hillPlot}},
  	\code{\link{gevFit}}. 
  
}


\examples{
## Extremal Index for the right and left tails 
## of the BMW log returns:
   xmpExtremes("\nStart: Plot the Extremal Index >")
   data(bmw)
   par(mfrow = c(2, 2), cex = 0.7)
   exindexPlot( bmw, block = "quarter")
   exindexPlot(-bmw, block = "quarter")   
   
## Extremal Index for the right and left tails 
## of the BMW log returns:
   xmpExtremes("\nNext: Investigate Tail Depth Dependence >")
   data(bmw)
   exindexesPlot( bmw, block = 65)
   exindexesPlot(-bmw, block = 65)   
}


\keyword{hplot}


\eof
\name{fExtremesTools}


\alias{fExtremesTools}

\alias{xmpExtremes}
\alias{xmpfExtremes}


\title{fExtremes Tools}


\description{

	Popups the example menu and starts or continues the example 
	and demo programs.
	
}


\usage{
xmpfExtremes()
xmpExtremes(prompt = "")
}


\arguments{

  	\item{prompt}{
		the string printed when prompting the user for input. 
		}	
}


\value{
  
	xmpfExtremes
	\cr
	Popups the example menu.
	\cr
	
	xmpExtremes
	\cr
	Nothing, the default, or the the prompt if you have set
	\code{xmpExtremes = readline} on the command prompt. 
	
}


\details{

	The example in the manual pages may be interactive and ask for
	input from the user. To achieve this you have to type on the
	command line: \code{xmpExtremes = readline}

}


\examples{
## currently none ...
}


\author{

	Diethelm Wuertz for this R-Port.

}


\keyword{hplot}


\eof
